
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.std_logic_arith.all;
-- Uncomment the following library declaration if instantiating
-- any Xilinx primitives in this code.
library UNISIM;
use UNISIM.VComponents.all;

use work.progMemInit_pkg_prog_adr_space.all;

entity ProgMem is
    Port ( ClkxC : in  STD_LOGIC;
           RstxR : in  STD_LOGIC;
           AdrxDI : in  STD_LOGIC_VECTOR (13 downto 0);
           DoutxDO : out  STD_LOGIC_VECTOR (15 downto 0));
end ProgMem;

architecture Behavioral of ProgMem is

--	type BlockOutType is array (0 to 7) of Std_logic_vector(31 downto 0);
		type BlockOutType is array (0 to 7) of Std_logic_vector(15 downto 0);
	Signal BlockOutxD : BlockOutType;

begin

		BRamInst0 : RAMB16_S1
		generic map (
			INIT => X"00000", --  Value of output RAM registers at startup
			SRVAL => X"00000", --  Ouput value upon SSR assertion
			INIT_00 => ProgMemInst_BRamInst0_INIT_00,
			INIT_01 => ProgMemInst_BRamInst0_INIT_01,
			INIT_02 => ProgMemInst_BRamInst0_INIT_02,
			INIT_03 => ProgMemInst_BRamInst0_INIT_03,
			INIT_04 => ProgMemInst_BRamInst0_INIT_04,
			INIT_05 => ProgMemInst_BRamInst0_INIT_05,
			INIT_06 => ProgMemInst_BRamInst0_INIT_06,
			INIT_07 => ProgMemInst_BRamInst0_INIT_07,
			INIT_08 => ProgMemInst_BRamInst0_INIT_08,
			INIT_09 => ProgMemInst_BRamInst0_INIT_09,
			INIT_0A => ProgMemInst_BRamInst0_INIT_0A,
			INIT_0B => ProgMemInst_BRamInst0_INIT_0B,
			INIT_0C => ProgMemInst_BRamInst0_INIT_0C,
			INIT_0D => ProgMemInst_BRamInst0_INIT_0D,
			INIT_0E => ProgMemInst_BRamInst0_INIT_0E,
			INIT_0F => ProgMemInst_BRamInst0_INIT_0F,
			INIT_10 => ProgMemInst_BRamInst0_INIT_10,
			INIT_11 => ProgMemInst_BRamInst0_INIT_11,
			INIT_12 => ProgMemInst_BRamInst0_INIT_12,
			INIT_13 => ProgMemInst_BRamInst0_INIT_13,
			INIT_14 => ProgMemInst_BRamInst0_INIT_14,
			INIT_15 => ProgMemInst_BRamInst0_INIT_15,
			INIT_16 => ProgMemInst_BRamInst0_INIT_16,
			INIT_17 => ProgMemInst_BRamInst0_INIT_17,
			INIT_18 => ProgMemInst_BRamInst0_INIT_18,
			INIT_19 => ProgMemInst_BRamInst0_INIT_19,
			INIT_1A => ProgMemInst_BRamInst0_INIT_1A,
			INIT_1B => ProgMemInst_BRamInst0_INIT_1B,
			INIT_1C => ProgMemInst_BRamInst0_INIT_1C,
			INIT_1D => ProgMemInst_BRamInst0_INIT_1D,
			INIT_1E => ProgMemInst_BRamInst0_INIT_1E,
			INIT_1F => ProgMemInst_BRamInst0_INIT_1F,
			INIT_20 => ProgMemInst_BRamInst0_INIT_10,
			INIT_21 => ProgMemInst_BRamInst0_INIT_21,
			INIT_22 => ProgMemInst_BRamInst0_INIT_22,
			INIT_23 => ProgMemInst_BRamInst0_INIT_23,
			INIT_24 => ProgMemInst_BRamInst0_INIT_24,
			INIT_25 => ProgMemInst_BRamInst0_INIT_25,
			INIT_26 => ProgMemInst_BRamInst0_INIT_26,
			INIT_27 => ProgMemInst_BRamInst0_INIT_27,
			INIT_28 => ProgMemInst_BRamInst0_INIT_28,
			INIT_29 => ProgMemInst_BRamInst0_INIT_29,
			INIT_2A => ProgMemInst_BRamInst0_INIT_2A,
			INIT_2B => ProgMemInst_BRamInst0_INIT_2B,
			INIT_2C => ProgMemInst_BRamInst0_INIT_2C,
			INIT_2D => ProgMemInst_BRamInst0_INIT_2D,
			INIT_2E => ProgMemInst_BRamInst0_INIT_2E,
			INIT_2F => ProgMemInst_BRamInst0_INIT_2F,
			INIT_30 => ProgMemInst_BRamInst0_INIT_30,
			INIT_31 => ProgMemInst_BRamInst0_INIT_31,
			INIT_32 => ProgMemInst_BRamInst0_INIT_32,
			INIT_33 => ProgMemInst_BRamInst0_INIT_33,
			INIT_34 => ProgMemInst_BRamInst0_INIT_34,
			INIT_35 => ProgMemInst_BRamInst0_INIT_35,
			INIT_36 => ProgMemInst_BRamInst0_INIT_36,
			INIT_37 => ProgMemInst_BRamInst0_INIT_37,
			INIT_38 => ProgMemInst_BRamInst0_INIT_38,
			INIT_39 => ProgMemInst_BRamInst0_INIT_39,
			INIT_3A => ProgMemInst_BRamInst0_INIT_3A,
			INIT_3B => ProgMemInst_BRamInst0_INIT_3B,
			INIT_3C => ProgMemInst_BRamInst0_INIT_3C,
			INIT_3D => ProgMemInst_BRamInst0_INIT_3D,
			INIT_3E => ProgMemInst_BRamInst0_INIT_3E,
			INIT_3F => ProgMemInst_BRamInst0_INIT_3F,                     
			WRITE_MODE => "WRITE_FIRST" --  WRITE_FIRST, READ_FIRST or NO_CHANGE
		)
			port map (
			DO => DoutxDO(0 downto 0),
			ADDR => AdrxDI,  		-- Address Input
			CLK => ClkxC,    		-- Clock
			DI => "0",      		-- Data Input
			EN => '1',      		-- RAM Enable Input
			SSR => RstxR,    		-- Synchronous Set/Reset Input
			WE => '0'       		-- Write Enable Input
		);
--	end generate;
		BRamInst1 : RAMB16_S1
		generic map (
			INIT => X"00000", --  Value of output RAM registers at startup
			SRVAL => X"00000", --  Ouput value upon SSR assertion
			INIT_00 => ProgMemInst_BRamInst1_INIT_00,
			INIT_01 => ProgMemInst_BRamInst1_INIT_01,
			INIT_02 => ProgMemInst_BRamInst1_INIT_02,
			INIT_03 => ProgMemInst_BRamInst1_INIT_03,
			INIT_04 => ProgMemInst_BRamInst1_INIT_04,
			INIT_05 => ProgMemInst_BRamInst1_INIT_05,
			INIT_06 => ProgMemInst_BRamInst1_INIT_06,
			INIT_07 => ProgMemInst_BRamInst1_INIT_07,
			INIT_08 => ProgMemInst_BRamInst1_INIT_08,
			INIT_09 => ProgMemInst_BRamInst1_INIT_09,
			INIT_0A => ProgMemInst_BRamInst1_INIT_0A,
			INIT_0B => ProgMemInst_BRamInst1_INIT_0B,
			INIT_0C => ProgMemInst_BRamInst1_INIT_0C,
			INIT_0D => ProgMemInst_BRamInst1_INIT_0D,
			INIT_0E => ProgMemInst_BRamInst1_INIT_0E,
			INIT_0F => ProgMemInst_BRamInst1_INIT_0F,
			INIT_10 => ProgMemInst_BRamInst1_INIT_10,
			INIT_11 => ProgMemInst_BRamInst1_INIT_11,
			INIT_12 => ProgMemInst_BRamInst1_INIT_12,
			INIT_13 => ProgMemInst_BRamInst1_INIT_13,
			INIT_14 => ProgMemInst_BRamInst1_INIT_14,
			INIT_15 => ProgMemInst_BRamInst1_INIT_15,
			INIT_16 => ProgMemInst_BRamInst1_INIT_16,
			INIT_17 => ProgMemInst_BRamInst1_INIT_17,
			INIT_18 => ProgMemInst_BRamInst1_INIT_18,
			INIT_19 => ProgMemInst_BRamInst1_INIT_19,
			INIT_1A => ProgMemInst_BRamInst1_INIT_1A,
			INIT_1B => ProgMemInst_BRamInst1_INIT_1B,
			INIT_1C => ProgMemInst_BRamInst1_INIT_1C,
			INIT_1D => ProgMemInst_BRamInst1_INIT_1D,
			INIT_1E => ProgMemInst_BRamInst1_INIT_1E,
			INIT_1F => ProgMemInst_BRamInst1_INIT_1F,
			INIT_20 => ProgMemInst_BRamInst1_INIT_10,
			INIT_21 => ProgMemInst_BRamInst1_INIT_21,
			INIT_22 => ProgMemInst_BRamInst1_INIT_22,
			INIT_23 => ProgMemInst_BRamInst1_INIT_23,
			INIT_24 => ProgMemInst_BRamInst1_INIT_24,
			INIT_25 => ProgMemInst_BRamInst1_INIT_25,
			INIT_26 => ProgMemInst_BRamInst1_INIT_26,
			INIT_27 => ProgMemInst_BRamInst1_INIT_27,
			INIT_28 => ProgMemInst_BRamInst1_INIT_28,
			INIT_29 => ProgMemInst_BRamInst1_INIT_29,
			INIT_2A => ProgMemInst_BRamInst1_INIT_2A,
			INIT_2B => ProgMemInst_BRamInst1_INIT_2B,
			INIT_2C => ProgMemInst_BRamInst1_INIT_2C,
			INIT_2D => ProgMemInst_BRamInst1_INIT_2D,
			INIT_2E => ProgMemInst_BRamInst1_INIT_2E,
			INIT_2F => ProgMemInst_BRamInst1_INIT_2F,
			INIT_30 => ProgMemInst_BRamInst1_INIT_30,
			INIT_31 => ProgMemInst_BRamInst1_INIT_31,
			INIT_32 => ProgMemInst_BRamInst1_INIT_32,
			INIT_33 => ProgMemInst_BRamInst1_INIT_33,
			INIT_34 => ProgMemInst_BRamInst1_INIT_34,
			INIT_35 => ProgMemInst_BRamInst1_INIT_35,
			INIT_36 => ProgMemInst_BRamInst1_INIT_36,
			INIT_37 => ProgMemInst_BRamInst1_INIT_37,
			INIT_38 => ProgMemInst_BRamInst1_INIT_38,
			INIT_39 => ProgMemInst_BRamInst1_INIT_39,
			INIT_3A => ProgMemInst_BRamInst1_INIT_3A,
			INIT_3B => ProgMemInst_BRamInst1_INIT_3B,
			INIT_3C => ProgMemInst_BRamInst1_INIT_3C,
			INIT_3D => ProgMemInst_BRamInst1_INIT_3D,
			INIT_3E => ProgMemInst_BRamInst1_INIT_3E,
			INIT_3F => ProgMemInst_BRamInst1_INIT_3F,
			WRITE_MODE => "WRITE_FIRST" --  WRITE_FIRST, READ_FIRST or NO_CHANGE
		)
			port map (
			DO => DoutxDO(1 downto 1),
			ADDR => AdrxDI,  		-- Address Input
			CLK => ClkxC,    		-- Clock
			DI => "0",      		-- Data Input
			EN => '1',      		-- RAM Enable Input
			SSR => RstxR,    		-- Synchronous Set/Reset Input
			WE => '0'       		-- Write Enable Input
		);
		BRamInst2 : RAMB16_S1
		generic map (
			INIT => X"00000", --  Value of output RAM registers at startup
			SRVAL => X"00000", --  Ouput value upon SSR assertion   
			INIT_00 => ProgMemInst_BRamInst2_INIT_00,
			INIT_01 => ProgMemInst_BRamInst2_INIT_01,
			INIT_02 => ProgMemInst_BRamInst2_INIT_02,
			INIT_03 => ProgMemInst_BRamInst2_INIT_03,
			INIT_04 => ProgMemInst_BRamInst2_INIT_04,
			INIT_05 => ProgMemInst_BRamInst2_INIT_05,
			INIT_06 => ProgMemInst_BRamInst2_INIT_06,
			INIT_07 => ProgMemInst_BRamInst2_INIT_07,
			INIT_08 => ProgMemInst_BRamInst2_INIT_08,
			INIT_09 => ProgMemInst_BRamInst2_INIT_09,
			INIT_0A => ProgMemInst_BRamInst2_INIT_0A,
			INIT_0B => ProgMemInst_BRamInst2_INIT_0B,
			INIT_0C => ProgMemInst_BRamInst2_INIT_0C,
			INIT_0D => ProgMemInst_BRamInst2_INIT_0D,
			INIT_0E => ProgMemInst_BRamInst2_INIT_0E,
			INIT_0F => ProgMemInst_BRamInst2_INIT_0F,
			INIT_10 => ProgMemInst_BRamInst2_INIT_10,
			INIT_11 => ProgMemInst_BRamInst2_INIT_11,
			INIT_12 => ProgMemInst_BRamInst2_INIT_12,
			INIT_13 => ProgMemInst_BRamInst2_INIT_13,
			INIT_14 => ProgMemInst_BRamInst2_INIT_14,
			INIT_15 => ProgMemInst_BRamInst2_INIT_15,
			INIT_16 => ProgMemInst_BRamInst2_INIT_16,
			INIT_17 => ProgMemInst_BRamInst2_INIT_17,
			INIT_18 => ProgMemInst_BRamInst2_INIT_18,
			INIT_19 => ProgMemInst_BRamInst2_INIT_19,
			INIT_1A => ProgMemInst_BRamInst2_INIT_1A,
			INIT_1B => ProgMemInst_BRamInst2_INIT_1B,
			INIT_1C => ProgMemInst_BRamInst2_INIT_1C,
			INIT_1D => ProgMemInst_BRamInst2_INIT_1D,
			INIT_1E => ProgMemInst_BRamInst2_INIT_1E,
			INIT_1F => ProgMemInst_BRamInst2_INIT_1F,
			INIT_20 => ProgMemInst_BRamInst2_INIT_10,
			INIT_21 => ProgMemInst_BRamInst2_INIT_21,
			INIT_22 => ProgMemInst_BRamInst2_INIT_22,
			INIT_23 => ProgMemInst_BRamInst2_INIT_23,
			INIT_24 => ProgMemInst_BRamInst2_INIT_24,
			INIT_25 => ProgMemInst_BRamInst2_INIT_25,
			INIT_26 => ProgMemInst_BRamInst2_INIT_26,
			INIT_27 => ProgMemInst_BRamInst2_INIT_27,
			INIT_28 => ProgMemInst_BRamInst2_INIT_28,
			INIT_29 => ProgMemInst_BRamInst2_INIT_29,
			INIT_2A => ProgMemInst_BRamInst2_INIT_2A,
			INIT_2B => ProgMemInst_BRamInst2_INIT_2B,
			INIT_2C => ProgMemInst_BRamInst2_INIT_2C,
			INIT_2D => ProgMemInst_BRamInst2_INIT_2D,
			INIT_2E => ProgMemInst_BRamInst2_INIT_2E,
			INIT_2F => ProgMemInst_BRamInst2_INIT_2F,
			INIT_30 => ProgMemInst_BRamInst2_INIT_30,
			INIT_31 => ProgMemInst_BRamInst2_INIT_31,
			INIT_32 => ProgMemInst_BRamInst2_INIT_32,
			INIT_33 => ProgMemInst_BRamInst2_INIT_33,
			INIT_34 => ProgMemInst_BRamInst2_INIT_34,
			INIT_35 => ProgMemInst_BRamInst2_INIT_35,
			INIT_36 => ProgMemInst_BRamInst2_INIT_36,
			INIT_37 => ProgMemInst_BRamInst2_INIT_37,
			INIT_38 => ProgMemInst_BRamInst2_INIT_38,
			INIT_39 => ProgMemInst_BRamInst2_INIT_39,
			INIT_3A => ProgMemInst_BRamInst2_INIT_3A,
			INIT_3B => ProgMemInst_BRamInst2_INIT_3B,
			INIT_3C => ProgMemInst_BRamInst2_INIT_3C,
			INIT_3D => ProgMemInst_BRamInst2_INIT_3D,
			INIT_3E => ProgMemInst_BRamInst2_INIT_3E,
			INIT_3F => ProgMemInst_BRamInst2_INIT_3F,
			WRITE_MODE => "WRITE_FIRST" --  WRITE_FIRST, READ_FIRST or NO_CHANGE
		)
			port map (
			DO => DoutxDO(2 downto 2),
			ADDR => AdrxDI,  		-- Address Input
			CLK => ClkxC,    		-- Clock
			DI => "0",      		-- Data Input
			EN => '1',      		-- RAM Enable Input
			SSR => RstxR,    		-- Synchronous Set/Reset Input
			WE => '0'       		-- Write Enable Input
		);
		BRamInst3 : RAMB16_S1
		generic map (
			INIT => X"00000", --  Value of output RAM registers at startup
			SRVAL => X"00000", --  Ouput value upon SSR assertion
			INIT_00 => ProgMemInst_BRamInst3_INIT_00,
			INIT_01 => ProgMemInst_BRamInst3_INIT_01,
			INIT_02 => ProgMemInst_BRamInst3_INIT_02,
			INIT_03 => ProgMemInst_BRamInst3_INIT_03,
			INIT_04 => ProgMemInst_BRamInst3_INIT_04,
			INIT_05 => ProgMemInst_BRamInst3_INIT_05,
			INIT_06 => ProgMemInst_BRamInst3_INIT_06,
			INIT_07 => ProgMemInst_BRamInst3_INIT_07,
			INIT_08 => ProgMemInst_BRamInst3_INIT_08,
			INIT_09 => ProgMemInst_BRamInst3_INIT_09,
			INIT_0A => ProgMemInst_BRamInst3_INIT_0A,
			INIT_0B => ProgMemInst_BRamInst3_INIT_0B,
			INIT_0C => ProgMemInst_BRamInst3_INIT_0C,
			INIT_0D => ProgMemInst_BRamInst3_INIT_0D,
			INIT_0E => ProgMemInst_BRamInst3_INIT_0E,
			INIT_0F => ProgMemInst_BRamInst3_INIT_0F,
			INIT_10 => ProgMemInst_BRamInst3_INIT_10,
			INIT_11 => ProgMemInst_BRamInst3_INIT_11,
			INIT_12 => ProgMemInst_BRamInst3_INIT_12,
			INIT_13 => ProgMemInst_BRamInst3_INIT_13,
			INIT_14 => ProgMemInst_BRamInst3_INIT_14,
			INIT_15 => ProgMemInst_BRamInst3_INIT_15,
			INIT_16 => ProgMemInst_BRamInst3_INIT_16,
			INIT_17 => ProgMemInst_BRamInst3_INIT_17,
			INIT_18 => ProgMemInst_BRamInst3_INIT_18,
			INIT_19 => ProgMemInst_BRamInst3_INIT_19,
			INIT_1A => ProgMemInst_BRamInst3_INIT_1A,
			INIT_1B => ProgMemInst_BRamInst3_INIT_1B,
			INIT_1C => ProgMemInst_BRamInst3_INIT_1C,
			INIT_1D => ProgMemInst_BRamInst3_INIT_1D,
			INIT_1E => ProgMemInst_BRamInst3_INIT_1E,
			INIT_1F => ProgMemInst_BRamInst3_INIT_1F,
			INIT_20 => ProgMemInst_BRamInst3_INIT_10,
			INIT_21 => ProgMemInst_BRamInst3_INIT_21,
			INIT_22 => ProgMemInst_BRamInst3_INIT_22,
			INIT_23 => ProgMemInst_BRamInst3_INIT_23,
			INIT_24 => ProgMemInst_BRamInst3_INIT_24,
			INIT_25 => ProgMemInst_BRamInst3_INIT_25,
			INIT_26 => ProgMemInst_BRamInst3_INIT_26,
			INIT_27 => ProgMemInst_BRamInst3_INIT_27,
			INIT_28 => ProgMemInst_BRamInst3_INIT_28,
			INIT_29 => ProgMemInst_BRamInst3_INIT_29,
			INIT_2A => ProgMemInst_BRamInst3_INIT_2A,
			INIT_2B => ProgMemInst_BRamInst3_INIT_2B,
			INIT_2C => ProgMemInst_BRamInst3_INIT_2C,
			INIT_2D => ProgMemInst_BRamInst3_INIT_2D,
			INIT_2E => ProgMemInst_BRamInst3_INIT_2E,
			INIT_2F => ProgMemInst_BRamInst3_INIT_2F,
			INIT_30 => ProgMemInst_BRamInst3_INIT_30,
			INIT_31 => ProgMemInst_BRamInst3_INIT_31,
			INIT_32 => ProgMemInst_BRamInst3_INIT_32,
			INIT_33 => ProgMemInst_BRamInst3_INIT_33,
			INIT_34 => ProgMemInst_BRamInst3_INIT_34,
			INIT_35 => ProgMemInst_BRamInst3_INIT_35,
			INIT_36 => ProgMemInst_BRamInst3_INIT_36,
			INIT_37 => ProgMemInst_BRamInst3_INIT_37,
			INIT_38 => ProgMemInst_BRamInst3_INIT_38,
			INIT_39 => ProgMemInst_BRamInst3_INIT_39,
			INIT_3A => ProgMemInst_BRamInst3_INIT_3A,
			INIT_3B => ProgMemInst_BRamInst3_INIT_3B,
			INIT_3C => ProgMemInst_BRamInst3_INIT_3C,
			INIT_3D => ProgMemInst_BRamInst3_INIT_3D,
			INIT_3E => ProgMemInst_BRamInst3_INIT_3E,
			INIT_3F => ProgMemInst_BRamInst3_INIT_3F,
			
			WRITE_MODE => "WRITE_FIRST" --  WRITE_FIRST, READ_FIRST or NO_CHANGE
		)
			port map (
			DO => DoutxDO(3 downto 3),
			ADDR => AdrxDI,  		-- Address Input
			CLK => ClkxC,    		-- Clock
			DI => "0",      		-- Data Input
			EN => '1',      		-- RAM Enable Input
			SSR => RstxR,    		-- Synchronous Set/Reset Input
			WE => '0'       		-- Write Enable Input
		);
		BRamInst4 : RAMB16_S1
		generic map (
			INIT => X"00000", --  Value of output RAM registers at startup
			SRVAL => X"00000", --  Ouput value upon SSR assertion
			INIT_00 => ProgMemInst_BRamInst4_INIT_00,
			INIT_01 => ProgMemInst_BRamInst4_INIT_01,
			INIT_02 => ProgMemInst_BRamInst4_INIT_02,
			INIT_03 => ProgMemInst_BRamInst4_INIT_03,
			INIT_04 => ProgMemInst_BRamInst4_INIT_04,
			INIT_05 => ProgMemInst_BRamInst4_INIT_05,
			INIT_06 => ProgMemInst_BRamInst4_INIT_06,
			INIT_07 => ProgMemInst_BRamInst4_INIT_07,
			INIT_08 => ProgMemInst_BRamInst4_INIT_08,
			INIT_09 => ProgMemInst_BRamInst4_INIT_09,
			INIT_0A => ProgMemInst_BRamInst4_INIT_0A,
			INIT_0B => ProgMemInst_BRamInst4_INIT_0B,
			INIT_0C => ProgMemInst_BRamInst4_INIT_0C,
			INIT_0D => ProgMemInst_BRamInst4_INIT_0D,
			INIT_0E => ProgMemInst_BRamInst4_INIT_0E,
			INIT_0F => ProgMemInst_BRamInst4_INIT_0F,
			INIT_10 => ProgMemInst_BRamInst4_INIT_10,
			INIT_11 => ProgMemInst_BRamInst4_INIT_11,
			INIT_12 => ProgMemInst_BRamInst4_INIT_12,
			INIT_13 => ProgMemInst_BRamInst4_INIT_13,
			INIT_14 => ProgMemInst_BRamInst4_INIT_14,
			INIT_15 => ProgMemInst_BRamInst4_INIT_15,
			INIT_16 => ProgMemInst_BRamInst4_INIT_16,
			INIT_17 => ProgMemInst_BRamInst4_INIT_17,
			INIT_18 => ProgMemInst_BRamInst4_INIT_18,
			INIT_19 => ProgMemInst_BRamInst4_INIT_19,
			INIT_1A => ProgMemInst_BRamInst4_INIT_1A,
			INIT_1B => ProgMemInst_BRamInst4_INIT_1B,
			INIT_1C => ProgMemInst_BRamInst4_INIT_1C,
			INIT_1D => ProgMemInst_BRamInst4_INIT_1D,
			INIT_1E => ProgMemInst_BRamInst4_INIT_1E,
			INIT_1F => ProgMemInst_BRamInst4_INIT_1F,
			INIT_20 => ProgMemInst_BRamInst4_INIT_10,
			INIT_21 => ProgMemInst_BRamInst4_INIT_21,
			INIT_22 => ProgMemInst_BRamInst4_INIT_22,
			INIT_23 => ProgMemInst_BRamInst4_INIT_23,
			INIT_24 => ProgMemInst_BRamInst4_INIT_24,
			INIT_25 => ProgMemInst_BRamInst4_INIT_25,
			INIT_26 => ProgMemInst_BRamInst4_INIT_26,
			INIT_27 => ProgMemInst_BRamInst4_INIT_27,
			INIT_28 => ProgMemInst_BRamInst4_INIT_28,
			INIT_29 => ProgMemInst_BRamInst4_INIT_29,
			INIT_2A => ProgMemInst_BRamInst4_INIT_2A,
			INIT_2B => ProgMemInst_BRamInst4_INIT_2B,
			INIT_2C => ProgMemInst_BRamInst4_INIT_2C,
			INIT_2D => ProgMemInst_BRamInst4_INIT_2D,
			INIT_2E => ProgMemInst_BRamInst4_INIT_2E,
			INIT_2F => ProgMemInst_BRamInst4_INIT_2F,
			INIT_30 => ProgMemInst_BRamInst4_INIT_30,
			INIT_31 => ProgMemInst_BRamInst4_INIT_31,
			INIT_32 => ProgMemInst_BRamInst4_INIT_32,
			INIT_33 => ProgMemInst_BRamInst4_INIT_33,
			INIT_34 => ProgMemInst_BRamInst4_INIT_34,
			INIT_35 => ProgMemInst_BRamInst4_INIT_35,
			INIT_36 => ProgMemInst_BRamInst4_INIT_36,
			INIT_37 => ProgMemInst_BRamInst4_INIT_37,
			INIT_38 => ProgMemInst_BRamInst4_INIT_38,
			INIT_39 => ProgMemInst_BRamInst4_INIT_39,
			INIT_3A => ProgMemInst_BRamInst4_INIT_3A,
			INIT_3B => ProgMemInst_BRamInst4_INIT_3B,
			INIT_3C => ProgMemInst_BRamInst4_INIT_3C,
			INIT_3D => ProgMemInst_BRamInst4_INIT_3D,
			INIT_3E => ProgMemInst_BRamInst4_INIT_3E,
			INIT_3F => ProgMemInst_BRamInst4_INIT_3F,
			WRITE_MODE => "WRITE_FIRST" --  WRITE_FIRST, READ_FIRST or NO_CHANGE
		)
			port map (
			DO => DoutxDO(4 downto 4),
			ADDR => AdrxDI,  		-- Address Input
			CLK => ClkxC,    		-- Clock
			DI => "0",      		-- Data Input
			EN => '1',      		-- RAM Enable Input
			SSR => RstxR,    		-- Synchronous Set/Reset Input
			WE => '0'       		-- Write Enable Input
		);
		BRamInst5 : RAMB16_S1
		generic map (
			INIT => X"00000", --  Value of output RAM registers at startup
			SRVAL => X"00000", --  Ouput value upon SSR assertion
			INIT_00 => ProgMemInst_BRamInst5_INIT_00,
			INIT_01 => ProgMemInst_BRamInst5_INIT_01,
			INIT_02 => ProgMemInst_BRamInst5_INIT_02,
			INIT_03 => ProgMemInst_BRamInst5_INIT_03,
			INIT_04 => ProgMemInst_BRamInst5_INIT_04,
			INIT_05 => ProgMemInst_BRamInst5_INIT_05,
			INIT_06 => ProgMemInst_BRamInst5_INIT_06,
			INIT_07 => ProgMemInst_BRamInst5_INIT_07,
			INIT_08 => ProgMemInst_BRamInst5_INIT_08,
			INIT_09 => ProgMemInst_BRamInst5_INIT_09,
			INIT_0A => ProgMemInst_BRamInst5_INIT_0A,
			INIT_0B => ProgMemInst_BRamInst5_INIT_0B,
			INIT_0C => ProgMemInst_BRamInst5_INIT_0C,
			INIT_0D => ProgMemInst_BRamInst5_INIT_0D,
			INIT_0E => ProgMemInst_BRamInst5_INIT_0E,
			INIT_0F => ProgMemInst_BRamInst5_INIT_0F,
			INIT_10 => ProgMemInst_BRamInst5_INIT_10,
			INIT_11 => ProgMemInst_BRamInst5_INIT_11,
			INIT_12 => ProgMemInst_BRamInst5_INIT_12,
			INIT_13 => ProgMemInst_BRamInst5_INIT_13,
			INIT_14 => ProgMemInst_BRamInst5_INIT_14,
			INIT_15 => ProgMemInst_BRamInst5_INIT_15,
			INIT_16 => ProgMemInst_BRamInst5_INIT_16,
			INIT_17 => ProgMemInst_BRamInst5_INIT_17,
			INIT_18 => ProgMemInst_BRamInst5_INIT_18,
			INIT_19 => ProgMemInst_BRamInst5_INIT_19,
			INIT_1A => ProgMemInst_BRamInst5_INIT_1A,
			INIT_1B => ProgMemInst_BRamInst5_INIT_1B,
			INIT_1C => ProgMemInst_BRamInst5_INIT_1C,
			INIT_1D => ProgMemInst_BRamInst5_INIT_1D,
			INIT_1E => ProgMemInst_BRamInst5_INIT_1E,
			INIT_1F => ProgMemInst_BRamInst5_INIT_1F,
			INIT_20 => ProgMemInst_BRamInst5_INIT_10,
			INIT_21 => ProgMemInst_BRamInst5_INIT_21,
			INIT_22 => ProgMemInst_BRamInst5_INIT_22,
			INIT_23 => ProgMemInst_BRamInst5_INIT_23,
			INIT_24 => ProgMemInst_BRamInst5_INIT_24,
			INIT_25 => ProgMemInst_BRamInst5_INIT_25,
			INIT_26 => ProgMemInst_BRamInst5_INIT_26,
			INIT_27 => ProgMemInst_BRamInst5_INIT_27,
			INIT_28 => ProgMemInst_BRamInst5_INIT_28,
			INIT_29 => ProgMemInst_BRamInst5_INIT_29,
			INIT_2A => ProgMemInst_BRamInst5_INIT_2A,
			INIT_2B => ProgMemInst_BRamInst5_INIT_2B,
			INIT_2C => ProgMemInst_BRamInst5_INIT_2C,
			INIT_2D => ProgMemInst_BRamInst5_INIT_2D,
			INIT_2E => ProgMemInst_BRamInst5_INIT_2E,
			INIT_2F => ProgMemInst_BRamInst5_INIT_2F,
			INIT_30 => ProgMemInst_BRamInst5_INIT_30,
			INIT_31 => ProgMemInst_BRamInst5_INIT_31,
			INIT_32 => ProgMemInst_BRamInst5_INIT_32,
			INIT_33 => ProgMemInst_BRamInst5_INIT_33,
			INIT_34 => ProgMemInst_BRamInst5_INIT_34,
			INIT_35 => ProgMemInst_BRamInst5_INIT_35,
			INIT_36 => ProgMemInst_BRamInst5_INIT_36,
			INIT_37 => ProgMemInst_BRamInst5_INIT_37,
			INIT_38 => ProgMemInst_BRamInst5_INIT_38,
			INIT_39 => ProgMemInst_BRamInst5_INIT_39,
			INIT_3A => ProgMemInst_BRamInst5_INIT_3A,
			INIT_3B => ProgMemInst_BRamInst5_INIT_3B,
			INIT_3C => ProgMemInst_BRamInst5_INIT_3C,
			INIT_3D => ProgMemInst_BRamInst5_INIT_3D,
			INIT_3E => ProgMemInst_BRamInst5_INIT_3E,
			INIT_3F => ProgMemInst_BRamInst5_INIT_3F,
			WRITE_MODE => "WRITE_FIRST" --  WRITE_FIRST, READ_FIRST or NO_CHANGE
		)
			port map (
			DO => DoutxDO(5 downto 5),
			ADDR => AdrxDI,  		-- 10-bit Address Input
			CLK => ClkxC,    		-- Clock
			DI => "0",      		-- 16-bit Data Input
			EN => '1',      		-- RAM Enable Input
			SSR => RstxR,    		-- Synchronous Set/Reset Input
			WE => '0'       		-- Write Enable Input
		);
		BRamInst6 : RAMB16_S1
		generic map (
			INIT => X"00000", --  Value of output RAM registers at startup
			SRVAL => X"00000", --  Ouput value upon SSR assertion
			INIT_00 => ProgMemInst_BRamInst6_INIT_00,
			INIT_01 => ProgMemInst_BRamInst6_INIT_01,
			INIT_02 => ProgMemInst_BRamInst6_INIT_02,
			INIT_03 => ProgMemInst_BRamInst6_INIT_03,
			INIT_04 => ProgMemInst_BRamInst6_INIT_04,
			INIT_05 => ProgMemInst_BRamInst6_INIT_05,
			INIT_06 => ProgMemInst_BRamInst6_INIT_06,
			INIT_07 => ProgMemInst_BRamInst6_INIT_07,
			INIT_08 => ProgMemInst_BRamInst6_INIT_08,
			INIT_09 => ProgMemInst_BRamInst6_INIT_09,
			INIT_0A => ProgMemInst_BRamInst6_INIT_0A,
			INIT_0B => ProgMemInst_BRamInst6_INIT_0B,
			INIT_0C => ProgMemInst_BRamInst6_INIT_0C,
			INIT_0D => ProgMemInst_BRamInst6_INIT_0D,
			INIT_0E => ProgMemInst_BRamInst6_INIT_0E,
			INIT_0F => ProgMemInst_BRamInst6_INIT_0F,
			INIT_10 => ProgMemInst_BRamInst6_INIT_10,
			INIT_11 => ProgMemInst_BRamInst6_INIT_11,
			INIT_12 => ProgMemInst_BRamInst6_INIT_12,
			INIT_13 => ProgMemInst_BRamInst6_INIT_13,
			INIT_14 => ProgMemInst_BRamInst6_INIT_14,
			INIT_15 => ProgMemInst_BRamInst6_INIT_15,
			INIT_16 => ProgMemInst_BRamInst6_INIT_16,
			INIT_17 => ProgMemInst_BRamInst6_INIT_17,
			INIT_18 => ProgMemInst_BRamInst6_INIT_18,
			INIT_19 => ProgMemInst_BRamInst6_INIT_19,
			INIT_1A => ProgMemInst_BRamInst6_INIT_1A,
			INIT_1B => ProgMemInst_BRamInst6_INIT_1B,
			INIT_1C => ProgMemInst_BRamInst6_INIT_1C,
			INIT_1D => ProgMemInst_BRamInst6_INIT_1D,
			INIT_1E => ProgMemInst_BRamInst6_INIT_1E,
			INIT_1F => ProgMemInst_BRamInst6_INIT_1F,
			INIT_20 => ProgMemInst_BRamInst6_INIT_10,
			INIT_21 => ProgMemInst_BRamInst6_INIT_21,
			INIT_22 => ProgMemInst_BRamInst6_INIT_22,
			INIT_23 => ProgMemInst_BRamInst6_INIT_23,
			INIT_24 => ProgMemInst_BRamInst6_INIT_24,
			INIT_25 => ProgMemInst_BRamInst6_INIT_25,
			INIT_26 => ProgMemInst_BRamInst6_INIT_26,
			INIT_27 => ProgMemInst_BRamInst6_INIT_27,
			INIT_28 => ProgMemInst_BRamInst6_INIT_28,
			INIT_29 => ProgMemInst_BRamInst6_INIT_29,
			INIT_2A => ProgMemInst_BRamInst6_INIT_2A,
			INIT_2B => ProgMemInst_BRamInst6_INIT_2B,
			INIT_2C => ProgMemInst_BRamInst6_INIT_2C,
			INIT_2D => ProgMemInst_BRamInst6_INIT_2D,
			INIT_2E => ProgMemInst_BRamInst6_INIT_2E,
			INIT_2F => ProgMemInst_BRamInst6_INIT_2F,
			INIT_30 => ProgMemInst_BRamInst6_INIT_30,
			INIT_31 => ProgMemInst_BRamInst6_INIT_31,
			INIT_32 => ProgMemInst_BRamInst6_INIT_32,
			INIT_33 => ProgMemInst_BRamInst6_INIT_33,
			INIT_34 => ProgMemInst_BRamInst6_INIT_34,
			INIT_35 => ProgMemInst_BRamInst6_INIT_35,
			INIT_36 => ProgMemInst_BRamInst6_INIT_36,
			INIT_37 => ProgMemInst_BRamInst6_INIT_37,
			INIT_38 => ProgMemInst_BRamInst6_INIT_38,
			INIT_39 => ProgMemInst_BRamInst6_INIT_39,
			INIT_3A => ProgMemInst_BRamInst6_INIT_3A,
			INIT_3B => ProgMemInst_BRamInst6_INIT_3B,
			INIT_3C => ProgMemInst_BRamInst6_INIT_3C,
			INIT_3D => ProgMemInst_BRamInst6_INIT_3D,
			INIT_3E => ProgMemInst_BRamInst6_INIT_3E,
			INIT_3F => ProgMemInst_BRamInst6_INIT_3F,
			WRITE_MODE => "WRITE_FIRST" --  WRITE_FIRST, READ_FIRST or NO_CHANGE
		)
			port map (
			DO => DoutxDO(6 downto 6),
			ADDR => AdrxDI,  		-- Address Input
			CLK => ClkxC,    		-- Clock
			DI => "0",      		-- Data Input
			EN => '1',      		-- RAM Enable Input
			SSR => RstxR,    		-- Synchronous Set/Reset Input
			WE => '0'       		-- Write Enable Input
		);
		BRamInst7 : RAMB16_S1
		generic map (
			INIT => X"00000", --  Value of output RAM registers at startup
			SRVAL => X"00000", --  Ouput value upon SSR assertion
			INIT_00 => ProgMemInst_BRamInst7_INIT_00,
			INIT_01 => ProgMemInst_BRamInst7_INIT_01,
			INIT_02 => ProgMemInst_BRamInst7_INIT_02,
			INIT_03 => ProgMemInst_BRamInst7_INIT_03,
			INIT_04 => ProgMemInst_BRamInst7_INIT_04,
			INIT_05 => ProgMemInst_BRamInst7_INIT_05,
			INIT_06 => ProgMemInst_BRamInst7_INIT_06,
			INIT_07 => ProgMemInst_BRamInst7_INIT_07,
			INIT_08 => ProgMemInst_BRamInst7_INIT_08,
			INIT_09 => ProgMemInst_BRamInst7_INIT_09,
			INIT_0A => ProgMemInst_BRamInst7_INIT_0A,
			INIT_0B => ProgMemInst_BRamInst7_INIT_0B,
			INIT_0C => ProgMemInst_BRamInst7_INIT_0C,
			INIT_0D => ProgMemInst_BRamInst7_INIT_0D,
			INIT_0E => ProgMemInst_BRamInst7_INIT_0E,
			INIT_0F => ProgMemInst_BRamInst7_INIT_0F,
			INIT_10 => ProgMemInst_BRamInst7_INIT_10,
			INIT_11 => ProgMemInst_BRamInst7_INIT_11,
			INIT_12 => ProgMemInst_BRamInst7_INIT_12,
			INIT_13 => ProgMemInst_BRamInst7_INIT_13,
			INIT_14 => ProgMemInst_BRamInst7_INIT_14,
			INIT_15 => ProgMemInst_BRamInst7_INIT_15,
			INIT_16 => ProgMemInst_BRamInst7_INIT_16,
			INIT_17 => ProgMemInst_BRamInst7_INIT_17,
			INIT_18 => ProgMemInst_BRamInst7_INIT_18,
			INIT_19 => ProgMemInst_BRamInst7_INIT_19,
			INIT_1A => ProgMemInst_BRamInst7_INIT_1A,
			INIT_1B => ProgMemInst_BRamInst7_INIT_1B,
			INIT_1C => ProgMemInst_BRamInst7_INIT_1C,
			INIT_1D => ProgMemInst_BRamInst7_INIT_1D,
			INIT_1E => ProgMemInst_BRamInst7_INIT_1E,
			INIT_1F => ProgMemInst_BRamInst7_INIT_1F,
			INIT_20 => ProgMemInst_BRamInst7_INIT_10,
			INIT_21 => ProgMemInst_BRamInst7_INIT_21,
			INIT_22 => ProgMemInst_BRamInst7_INIT_22,
			INIT_23 => ProgMemInst_BRamInst7_INIT_23,
			INIT_24 => ProgMemInst_BRamInst7_INIT_24,
			INIT_25 => ProgMemInst_BRamInst7_INIT_25,
			INIT_26 => ProgMemInst_BRamInst7_INIT_26,
			INIT_27 => ProgMemInst_BRamInst7_INIT_27,
			INIT_28 => ProgMemInst_BRamInst7_INIT_28,
			INIT_29 => ProgMemInst_BRamInst7_INIT_29,
			INIT_2A => ProgMemInst_BRamInst7_INIT_2A,
			INIT_2B => ProgMemInst_BRamInst7_INIT_2B,
			INIT_2C => ProgMemInst_BRamInst7_INIT_2C,
			INIT_2D => ProgMemInst_BRamInst7_INIT_2D,
			INIT_2E => ProgMemInst_BRamInst7_INIT_2E,
			INIT_2F => ProgMemInst_BRamInst7_INIT_2F,
			INIT_30 => ProgMemInst_BRamInst7_INIT_30,
			INIT_31 => ProgMemInst_BRamInst7_INIT_31,
			INIT_32 => ProgMemInst_BRamInst7_INIT_32,
			INIT_33 => ProgMemInst_BRamInst7_INIT_33,
			INIT_34 => ProgMemInst_BRamInst7_INIT_34,
			INIT_35 => ProgMemInst_BRamInst7_INIT_35,
			INIT_36 => ProgMemInst_BRamInst7_INIT_36,
			INIT_37 => ProgMemInst_BRamInst7_INIT_37,
			INIT_38 => ProgMemInst_BRamInst7_INIT_38,
			INIT_39 => ProgMemInst_BRamInst7_INIT_39,
			INIT_3A => ProgMemInst_BRamInst7_INIT_3A,
			INIT_3B => ProgMemInst_BRamInst7_INIT_3B,
			INIT_3C => ProgMemInst_BRamInst7_INIT_3C,
			INIT_3D => ProgMemInst_BRamInst7_INIT_3D,
			INIT_3E => ProgMemInst_BRamInst7_INIT_3E,
			INIT_3F => ProgMemInst_BRamInst7_INIT_3F,
			WRITE_MODE => "WRITE_FIRST" --  WRITE_FIRST, READ_FIRST or NO_CHANGE
		)
			port map (
			DO => DoutxDO(7 downto 7),
			ADDR => AdrxDI,  		-- Address Input
			CLK => ClkxC,    		-- Clock
			DI => "0",      		-- Data Input
			EN => '1',      		-- RAM Enable Input
			SSR => RstxR,    		-- Synchronous Set/Reset Input
			WE => '0'       		-- Write Enable Input
		);
		
		BRamInst8 : RAMB16_S1
		generic map (
			INIT => X"00000", --  Value of output RAM registers at startup
			SRVAL => X"00000", --  Ouput value upon SSR assertion
			INIT_00 => ProgMemInst_BRamInst8_INIT_00,
			INIT_01 => ProgMemInst_BRamInst8_INIT_01,
			INIT_02 => ProgMemInst_BRamInst8_INIT_02,
			INIT_03 => ProgMemInst_BRamInst8_INIT_03,
			INIT_04 => ProgMemInst_BRamInst8_INIT_04,
			INIT_05 => ProgMemInst_BRamInst8_INIT_05,
			INIT_06 => ProgMemInst_BRamInst8_INIT_06,
			INIT_07 => ProgMemInst_BRamInst8_INIT_07,
			INIT_08 => ProgMemInst_BRamInst8_INIT_08,
			INIT_09 => ProgMemInst_BRamInst8_INIT_09,
			INIT_0A => ProgMemInst_BRamInst8_INIT_0A,
			INIT_0B => ProgMemInst_BRamInst8_INIT_0B,
			INIT_0C => ProgMemInst_BRamInst8_INIT_0C,
			INIT_0D => ProgMemInst_BRamInst8_INIT_0D,
			INIT_0E => ProgMemInst_BRamInst8_INIT_0E,
			INIT_0F => ProgMemInst_BRamInst8_INIT_0F,
			INIT_10 => ProgMemInst_BRamInst8_INIT_10,
			INIT_11 => ProgMemInst_BRamInst8_INIT_11,
			INIT_12 => ProgMemInst_BRamInst8_INIT_12,
			INIT_13 => ProgMemInst_BRamInst8_INIT_13,
			INIT_14 => ProgMemInst_BRamInst8_INIT_14,
			INIT_15 => ProgMemInst_BRamInst8_INIT_15,
			INIT_16 => ProgMemInst_BRamInst8_INIT_16,
			INIT_17 => ProgMemInst_BRamInst8_INIT_17,
			INIT_18 => ProgMemInst_BRamInst8_INIT_18,
			INIT_19 => ProgMemInst_BRamInst8_INIT_19,
			INIT_1A => ProgMemInst_BRamInst8_INIT_1A,
			INIT_1B => ProgMemInst_BRamInst8_INIT_1B,
			INIT_1C => ProgMemInst_BRamInst8_INIT_1C,
			INIT_1D => ProgMemInst_BRamInst8_INIT_1D,
			INIT_1E => ProgMemInst_BRamInst8_INIT_1E,
			INIT_1F => ProgMemInst_BRamInst8_INIT_1F,
			INIT_20 => ProgMemInst_BRamInst8_INIT_10,
			INIT_21 => ProgMemInst_BRamInst8_INIT_21,
			INIT_22 => ProgMemInst_BRamInst8_INIT_22,
			INIT_23 => ProgMemInst_BRamInst8_INIT_23,
			INIT_24 => ProgMemInst_BRamInst8_INIT_24,
			INIT_25 => ProgMemInst_BRamInst8_INIT_25,
			INIT_26 => ProgMemInst_BRamInst8_INIT_26,
			INIT_27 => ProgMemInst_BRamInst8_INIT_27,
			INIT_28 => ProgMemInst_BRamInst8_INIT_28,
			INIT_29 => ProgMemInst_BRamInst8_INIT_29,
			INIT_2A => ProgMemInst_BRamInst8_INIT_2A,
			INIT_2B => ProgMemInst_BRamInst8_INIT_2B,
			INIT_2C => ProgMemInst_BRamInst8_INIT_2C,
			INIT_2D => ProgMemInst_BRamInst8_INIT_2D,
			INIT_2E => ProgMemInst_BRamInst8_INIT_2E,
			INIT_2F => ProgMemInst_BRamInst8_INIT_2F,
			INIT_30 => ProgMemInst_BRamInst8_INIT_30,
			INIT_31 => ProgMemInst_BRamInst8_INIT_31,
			INIT_32 => ProgMemInst_BRamInst8_INIT_32,
			INIT_33 => ProgMemInst_BRamInst8_INIT_33,
			INIT_34 => ProgMemInst_BRamInst8_INIT_34,
			INIT_35 => ProgMemInst_BRamInst8_INIT_35,
			INIT_36 => ProgMemInst_BRamInst8_INIT_36,
			INIT_37 => ProgMemInst_BRamInst8_INIT_37,
			INIT_38 => ProgMemInst_BRamInst8_INIT_38,
			INIT_39 => ProgMemInst_BRamInst8_INIT_39,
			INIT_3A => ProgMemInst_BRamInst8_INIT_3A,
			INIT_3B => ProgMemInst_BRamInst8_INIT_3B,
			INIT_3C => ProgMemInst_BRamInst8_INIT_3C,
			INIT_3D => ProgMemInst_BRamInst8_INIT_3D,
			INIT_3E => ProgMemInst_BRamInst8_INIT_3E,
			INIT_3F => ProgMemInst_BRamInst8_INIT_3F,
			WRITE_MODE => "WRITE_FIRST" --  WRITE_FIRST, READ_FIRST or NO_CHANGE
		)
			port map (
			DO => DoutxDO(8 downto 8),
			ADDR => AdrxDI,  		-- Address Input
			CLK => ClkxC,    		-- Clock
			DI => "0",      		-- Data Input
			EN => '1',      		-- RAM Enable Input
			SSR => RstxR,    		-- Synchronous Set/Reset Input
			WE => '0'       		-- Write Enable Input
		);    
		
		BRamInst9 : RAMB16_S1
		generic map (
			INIT => X"00000", --  Value of output RAM registers at startup
			SRVAL => X"00000", --  Ouput value upon SSR assertion
			INIT_00 => ProgMemInst_BRamInst9_INIT_00,
			INIT_01 => ProgMemInst_BRamInst9_INIT_01,
			INIT_02 => ProgMemInst_BRamInst9_INIT_02,
			INIT_03 => ProgMemInst_BRamInst9_INIT_03,
			INIT_04 => ProgMemInst_BRamInst9_INIT_04,
			INIT_05 => ProgMemInst_BRamInst9_INIT_05,
			INIT_06 => ProgMemInst_BRamInst9_INIT_06,
			INIT_07 => ProgMemInst_BRamInst9_INIT_07,
			INIT_08 => ProgMemInst_BRamInst9_INIT_08,
			INIT_09 => ProgMemInst_BRamInst9_INIT_09,
			INIT_0A => ProgMemInst_BRamInst9_INIT_0A,
			INIT_0B => ProgMemInst_BRamInst9_INIT_0B,
			INIT_0C => ProgMemInst_BRamInst9_INIT_0C,
			INIT_0D => ProgMemInst_BRamInst9_INIT_0D,
			INIT_0E => ProgMemInst_BRamInst9_INIT_0E,
			INIT_0F => ProgMemInst_BRamInst9_INIT_0F,
			INIT_10 => ProgMemInst_BRamInst9_INIT_10,
			INIT_11 => ProgMemInst_BRamInst9_INIT_11,
			INIT_12 => ProgMemInst_BRamInst9_INIT_12,
			INIT_13 => ProgMemInst_BRamInst9_INIT_13,
			INIT_14 => ProgMemInst_BRamInst9_INIT_14,
			INIT_15 => ProgMemInst_BRamInst9_INIT_15,
			INIT_16 => ProgMemInst_BRamInst9_INIT_16,
			INIT_17 => ProgMemInst_BRamInst9_INIT_17,
			INIT_18 => ProgMemInst_BRamInst9_INIT_18,
			INIT_19 => ProgMemInst_BRamInst9_INIT_19,
			INIT_1A => ProgMemInst_BRamInst9_INIT_1A,
			INIT_1B => ProgMemInst_BRamInst9_INIT_1B,
			INIT_1C => ProgMemInst_BRamInst9_INIT_1C,
			INIT_1D => ProgMemInst_BRamInst9_INIT_1D,
			INIT_1E => ProgMemInst_BRamInst9_INIT_1E,
			INIT_1F => ProgMemInst_BRamInst9_INIT_1F,
			INIT_20 => ProgMemInst_BRamInst9_INIT_10,
			INIT_21 => ProgMemInst_BRamInst9_INIT_21,
			INIT_22 => ProgMemInst_BRamInst9_INIT_22,
			INIT_23 => ProgMemInst_BRamInst9_INIT_23,
			INIT_24 => ProgMemInst_BRamInst9_INIT_24,
			INIT_25 => ProgMemInst_BRamInst9_INIT_25,
			INIT_26 => ProgMemInst_BRamInst9_INIT_26,
			INIT_27 => ProgMemInst_BRamInst9_INIT_27,
			INIT_28 => ProgMemInst_BRamInst9_INIT_28,
			INIT_29 => ProgMemInst_BRamInst9_INIT_29,
			INIT_2A => ProgMemInst_BRamInst9_INIT_2A,
			INIT_2B => ProgMemInst_BRamInst9_INIT_2B,
			INIT_2C => ProgMemInst_BRamInst9_INIT_2C,
			INIT_2D => ProgMemInst_BRamInst9_INIT_2D,
			INIT_2E => ProgMemInst_BRamInst9_INIT_2E,
			INIT_2F => ProgMemInst_BRamInst9_INIT_2F,
			INIT_30 => ProgMemInst_BRamInst9_INIT_30,
			INIT_31 => ProgMemInst_BRamInst9_INIT_31,
			INIT_32 => ProgMemInst_BRamInst9_INIT_32,
			INIT_33 => ProgMemInst_BRamInst9_INIT_33,
			INIT_34 => ProgMemInst_BRamInst9_INIT_34,
			INIT_35 => ProgMemInst_BRamInst9_INIT_35,
			INIT_36 => ProgMemInst_BRamInst9_INIT_36,
			INIT_37 => ProgMemInst_BRamInst9_INIT_37,
			INIT_38 => ProgMemInst_BRamInst9_INIT_38,
			INIT_39 => ProgMemInst_BRamInst9_INIT_39,
			INIT_3A => ProgMemInst_BRamInst9_INIT_3A,
			INIT_3B => ProgMemInst_BRamInst9_INIT_3B,
			INIT_3C => ProgMemInst_BRamInst9_INIT_3C,
			INIT_3D => ProgMemInst_BRamInst9_INIT_3D,
			INIT_3E => ProgMemInst_BRamInst9_INIT_3E,
			INIT_3F => ProgMemInst_BRamInst9_INIT_3F,
			WRITE_MODE => "WRITE_FIRST" --  WRITE_FIRST, READ_FIRST or NO_CHANGE
		)
			port map (
			DO => DoutxDO(9 downto 9),
			ADDR => AdrxDI,  		-- Address Input
			CLK => ClkxC,    		-- Clock
			DI => "0",      		-- Data Input
			EN => '1',      		-- RAM Enable Input
			SSR => RstxR,    		-- Synchronous Set/Reset Input
			WE => '0'       		-- Write Enable Input
		);
             
		BRamInst10 : RAMB16_S1
		generic map (
			INIT => X"00000", --  Value of output RAM registers at startup
			SRVAL => X"00000", --  Ouput value upon SSR assertion
			INIT_00 => ProgMemInst_BRamInst10_INIT_00,
			INIT_01 => ProgMemInst_BRamInst10_INIT_01,
			INIT_02 => ProgMemInst_BRamInst10_INIT_02,
			INIT_03 => ProgMemInst_BRamInst10_INIT_03,
			INIT_04 => ProgMemInst_BRamInst10_INIT_04,
			INIT_05 => ProgMemInst_BRamInst10_INIT_05,
			INIT_06 => ProgMemInst_BRamInst10_INIT_06,
			INIT_07 => ProgMemInst_BRamInst10_INIT_07,
			INIT_08 => ProgMemInst_BRamInst10_INIT_08,
			INIT_09 => ProgMemInst_BRamInst10_INIT_09,
			INIT_0A => ProgMemInst_BRamInst10_INIT_0A,
			INIT_0B => ProgMemInst_BRamInst10_INIT_0B,
			INIT_0C => ProgMemInst_BRamInst10_INIT_0C,
			INIT_0D => ProgMemInst_BRamInst10_INIT_0D,
			INIT_0E => ProgMemInst_BRamInst10_INIT_0E,
			INIT_0F => ProgMemInst_BRamInst10_INIT_0F,
			INIT_10 => ProgMemInst_BRamInst10_INIT_10,
			INIT_11 => ProgMemInst_BRamInst10_INIT_11,
			INIT_12 => ProgMemInst_BRamInst10_INIT_12,
			INIT_13 => ProgMemInst_BRamInst10_INIT_13,
			INIT_14 => ProgMemInst_BRamInst10_INIT_14,
			INIT_15 => ProgMemInst_BRamInst10_INIT_15,
			INIT_16 => ProgMemInst_BRamInst10_INIT_16,
			INIT_17 => ProgMemInst_BRamInst10_INIT_17,
			INIT_18 => ProgMemInst_BRamInst10_INIT_18,
			INIT_19 => ProgMemInst_BRamInst10_INIT_19,
			INIT_1A => ProgMemInst_BRamInst10_INIT_1A,
			INIT_1B => ProgMemInst_BRamInst10_INIT_1B,
			INIT_1C => ProgMemInst_BRamInst10_INIT_1C,
			INIT_1D => ProgMemInst_BRamInst10_INIT_1D,
			INIT_1E => ProgMemInst_BRamInst10_INIT_1E,
			INIT_1F => ProgMemInst_BRamInst10_INIT_1F,
			INIT_20 => ProgMemInst_BRamInst10_INIT_10,
			INIT_21 => ProgMemInst_BRamInst10_INIT_21,
			INIT_22 => ProgMemInst_BRamInst10_INIT_22,
			INIT_23 => ProgMemInst_BRamInst10_INIT_23,
			INIT_24 => ProgMemInst_BRamInst10_INIT_24,
			INIT_25 => ProgMemInst_BRamInst10_INIT_25,
			INIT_26 => ProgMemInst_BRamInst10_INIT_26,
			INIT_27 => ProgMemInst_BRamInst10_INIT_27,
			INIT_28 => ProgMemInst_BRamInst10_INIT_28,
			INIT_29 => ProgMemInst_BRamInst10_INIT_29,
			INIT_2A => ProgMemInst_BRamInst10_INIT_2A,
			INIT_2B => ProgMemInst_BRamInst10_INIT_2B,
			INIT_2C => ProgMemInst_BRamInst10_INIT_2C,
			INIT_2D => ProgMemInst_BRamInst10_INIT_2D,
			INIT_2E => ProgMemInst_BRamInst10_INIT_2E,
			INIT_2F => ProgMemInst_BRamInst10_INIT_2F,
			INIT_30 => ProgMemInst_BRamInst10_INIT_30,
			INIT_31 => ProgMemInst_BRamInst10_INIT_31,
			INIT_32 => ProgMemInst_BRamInst10_INIT_32,
			INIT_33 => ProgMemInst_BRamInst10_INIT_33,
			INIT_34 => ProgMemInst_BRamInst10_INIT_34,
			INIT_35 => ProgMemInst_BRamInst10_INIT_35,
			INIT_36 => ProgMemInst_BRamInst10_INIT_36,
			INIT_37 => ProgMemInst_BRamInst10_INIT_37,
			INIT_38 => ProgMemInst_BRamInst10_INIT_38,
			INIT_39 => ProgMemInst_BRamInst10_INIT_39,
			INIT_3A => ProgMemInst_BRamInst10_INIT_3A,
			INIT_3B => ProgMemInst_BRamInst10_INIT_3B,
			INIT_3C => ProgMemInst_BRamInst10_INIT_3C,
			INIT_3D => ProgMemInst_BRamInst10_INIT_3D,
			INIT_3E => ProgMemInst_BRamInst10_INIT_3E,
			INIT_3F => ProgMemInst_BRamInst10_INIT_3F,
			WRITE_MODE => "WRITE_FIRST" --  WRITE_FIRST, READ_FIRST or NO_CHANGE
		)
			port map (
			DO => DoutxDO(10 downto 10),
			ADDR => AdrxDI,  		-- Address Input
			CLK => ClkxC,    		-- Clock
			DI => "0",      		-- Data Input
			EN => '1',      		-- RAM Enable Input
			SSR => RstxR,    		-- Synchronous Set/Reset Input
			WE => '0'       		-- Write Enable Input
		); 
		
		BRamInst11 : RAMB16_S1
		generic map (
			INIT => X"00000", --  Value of output RAM registers at startup
			SRVAL => X"00000", --  Ouput value upon SSR assertion
			INIT_00 => ProgMemInst_BRamInst11_INIT_00,
			INIT_01 => ProgMemInst_BRamInst11_INIT_01,
			INIT_02 => ProgMemInst_BRamInst11_INIT_02,
			INIT_03 => ProgMemInst_BRamInst11_INIT_03,
			INIT_04 => ProgMemInst_BRamInst11_INIT_04,
			INIT_05 => ProgMemInst_BRamInst11_INIT_05,
			INIT_06 => ProgMemInst_BRamInst11_INIT_06,
			INIT_07 => ProgMemInst_BRamInst11_INIT_07,
			INIT_08 => ProgMemInst_BRamInst11_INIT_08,
			INIT_09 => ProgMemInst_BRamInst11_INIT_09,
			INIT_0A => ProgMemInst_BRamInst11_INIT_0A,
			INIT_0B => ProgMemInst_BRamInst11_INIT_0B,
			INIT_0C => ProgMemInst_BRamInst11_INIT_0C,
			INIT_0D => ProgMemInst_BRamInst11_INIT_0D,
			INIT_0E => ProgMemInst_BRamInst11_INIT_0E,
			INIT_0F => ProgMemInst_BRamInst11_INIT_0F,
			INIT_10 => ProgMemInst_BRamInst11_INIT_10,
			INIT_11 => ProgMemInst_BRamInst11_INIT_11,
			INIT_12 => ProgMemInst_BRamInst11_INIT_12,
			INIT_13 => ProgMemInst_BRamInst11_INIT_13,
			INIT_14 => ProgMemInst_BRamInst11_INIT_14,
			INIT_15 => ProgMemInst_BRamInst11_INIT_15,
			INIT_16 => ProgMemInst_BRamInst11_INIT_16,
			INIT_17 => ProgMemInst_BRamInst11_INIT_17,
			INIT_18 => ProgMemInst_BRamInst11_INIT_18,
			INIT_19 => ProgMemInst_BRamInst11_INIT_19,
			INIT_1A => ProgMemInst_BRamInst11_INIT_1A,
			INIT_1B => ProgMemInst_BRamInst11_INIT_1B,
			INIT_1C => ProgMemInst_BRamInst11_INIT_1C,
			INIT_1D => ProgMemInst_BRamInst11_INIT_1D,
			INIT_1E => ProgMemInst_BRamInst11_INIT_1E,
			INIT_1F => ProgMemInst_BRamInst11_INIT_1F,
			INIT_20 => ProgMemInst_BRamInst11_INIT_10,
			INIT_21 => ProgMemInst_BRamInst11_INIT_21,
			INIT_22 => ProgMemInst_BRamInst11_INIT_22,
			INIT_23 => ProgMemInst_BRamInst11_INIT_23,
			INIT_24 => ProgMemInst_BRamInst11_INIT_24,
			INIT_25 => ProgMemInst_BRamInst11_INIT_25,
			INIT_26 => ProgMemInst_BRamInst11_INIT_26,
			INIT_27 => ProgMemInst_BRamInst11_INIT_27,
			INIT_28 => ProgMemInst_BRamInst11_INIT_28,
			INIT_29 => ProgMemInst_BRamInst11_INIT_29,
			INIT_2A => ProgMemInst_BRamInst11_INIT_2A,
			INIT_2B => ProgMemInst_BRamInst11_INIT_2B,
			INIT_2C => ProgMemInst_BRamInst11_INIT_2C,
			INIT_2D => ProgMemInst_BRamInst11_INIT_2D,
			INIT_2E => ProgMemInst_BRamInst11_INIT_2E,
			INIT_2F => ProgMemInst_BRamInst11_INIT_2F,
			INIT_30 => ProgMemInst_BRamInst11_INIT_30,
			INIT_31 => ProgMemInst_BRamInst11_INIT_31,
			INIT_32 => ProgMemInst_BRamInst11_INIT_32,
			INIT_33 => ProgMemInst_BRamInst11_INIT_33,
			INIT_34 => ProgMemInst_BRamInst11_INIT_34,
			INIT_35 => ProgMemInst_BRamInst11_INIT_35,
			INIT_36 => ProgMemInst_BRamInst11_INIT_36,
			INIT_37 => ProgMemInst_BRamInst11_INIT_37,
			INIT_38 => ProgMemInst_BRamInst11_INIT_38,
			INIT_39 => ProgMemInst_BRamInst11_INIT_39,
			INIT_3A => ProgMemInst_BRamInst11_INIT_3A,
			INIT_3B => ProgMemInst_BRamInst11_INIT_3B,
			INIT_3C => ProgMemInst_BRamInst11_INIT_3C,
			INIT_3D => ProgMemInst_BRamInst11_INIT_3D,
			INIT_3E => ProgMemInst_BRamInst11_INIT_3E,
			INIT_3F => ProgMemInst_BRamInst11_INIT_3F,
			WRITE_MODE => "WRITE_FIRST" --  WRITE_FIRST, READ_FIRST or NO_CHANGE
		)
			port map (
			DO => DoutxDO(11 downto 11),
			ADDR => AdrxDI,  		-- Address Input
			CLK => ClkxC,    		-- Clock
			DI => "0",      		-- Data Input
			EN => '1',      		-- RAM Enable Input
			SSR => RstxR,    		-- Synchronous Set/Reset Input
			WE => '0'       		-- Write Enable Input
		);         
		
		BRamInst12 : RAMB16_S1
		generic map (
			INIT => X"00000", --  Value of output RAM registers at startup
			SRVAL => X"00000", --  Ouput value upon SSR assertion
			INIT_00 => ProgMemInst_BRamInst12_INIT_00,
			INIT_01 => ProgMemInst_BRamInst12_INIT_01,
			INIT_02 => ProgMemInst_BRamInst12_INIT_02,
			INIT_03 => ProgMemInst_BRamInst12_INIT_03,
			INIT_04 => ProgMemInst_BRamInst12_INIT_04,
			INIT_05 => ProgMemInst_BRamInst12_INIT_05,
			INIT_06 => ProgMemInst_BRamInst12_INIT_06,
			INIT_07 => ProgMemInst_BRamInst12_INIT_07,
			INIT_08 => ProgMemInst_BRamInst12_INIT_08,
			INIT_09 => ProgMemInst_BRamInst12_INIT_09,
			INIT_0A => ProgMemInst_BRamInst12_INIT_0A,
			INIT_0B => ProgMemInst_BRamInst12_INIT_0B,
			INIT_0C => ProgMemInst_BRamInst12_INIT_0C,
			INIT_0D => ProgMemInst_BRamInst12_INIT_0D,
			INIT_0E => ProgMemInst_BRamInst12_INIT_0E,
			INIT_0F => ProgMemInst_BRamInst12_INIT_0F,
			INIT_10 => ProgMemInst_BRamInst12_INIT_10,
			INIT_11 => ProgMemInst_BRamInst12_INIT_11,
			INIT_12 => ProgMemInst_BRamInst12_INIT_12,
			INIT_13 => ProgMemInst_BRamInst12_INIT_13,
			INIT_14 => ProgMemInst_BRamInst12_INIT_14,
			INIT_15 => ProgMemInst_BRamInst12_INIT_15,
			INIT_16 => ProgMemInst_BRamInst12_INIT_16,
			INIT_17 => ProgMemInst_BRamInst12_INIT_17,
			INIT_18 => ProgMemInst_BRamInst12_INIT_18,
			INIT_19 => ProgMemInst_BRamInst12_INIT_19,
			INIT_1A => ProgMemInst_BRamInst12_INIT_1A,
			INIT_1B => ProgMemInst_BRamInst12_INIT_1B,
			INIT_1C => ProgMemInst_BRamInst12_INIT_1C,
			INIT_1D => ProgMemInst_BRamInst12_INIT_1D,
			INIT_1E => ProgMemInst_BRamInst12_INIT_1E,
			INIT_1F => ProgMemInst_BRamInst12_INIT_1F,
			INIT_20 => ProgMemInst_BRamInst12_INIT_10,
			INIT_21 => ProgMemInst_BRamInst12_INIT_21,
			INIT_22 => ProgMemInst_BRamInst12_INIT_22,
			INIT_23 => ProgMemInst_BRamInst12_INIT_23,
			INIT_24 => ProgMemInst_BRamInst12_INIT_24,
			INIT_25 => ProgMemInst_BRamInst12_INIT_25,
			INIT_26 => ProgMemInst_BRamInst12_INIT_26,
			INIT_27 => ProgMemInst_BRamInst12_INIT_27,
			INIT_28 => ProgMemInst_BRamInst12_INIT_28,
			INIT_29 => ProgMemInst_BRamInst12_INIT_29,
			INIT_2A => ProgMemInst_BRamInst12_INIT_2A,
			INIT_2B => ProgMemInst_BRamInst12_INIT_2B,
			INIT_2C => ProgMemInst_BRamInst12_INIT_2C,
			INIT_2D => ProgMemInst_BRamInst12_INIT_2D,
			INIT_2E => ProgMemInst_BRamInst12_INIT_2E,
			INIT_2F => ProgMemInst_BRamInst12_INIT_2F,
			INIT_30 => ProgMemInst_BRamInst12_INIT_30,
			INIT_31 => ProgMemInst_BRamInst12_INIT_31,
			INIT_32 => ProgMemInst_BRamInst12_INIT_32,
			INIT_33 => ProgMemInst_BRamInst12_INIT_33,
			INIT_34 => ProgMemInst_BRamInst12_INIT_34,
			INIT_35 => ProgMemInst_BRamInst12_INIT_35,
			INIT_36 => ProgMemInst_BRamInst12_INIT_36,
			INIT_37 => ProgMemInst_BRamInst12_INIT_37,
			INIT_38 => ProgMemInst_BRamInst12_INIT_38,
			INIT_39 => ProgMemInst_BRamInst12_INIT_39,
			INIT_3A => ProgMemInst_BRamInst12_INIT_3A,
			INIT_3B => ProgMemInst_BRamInst12_INIT_3B,
			INIT_3C => ProgMemInst_BRamInst12_INIT_3C,
			INIT_3D => ProgMemInst_BRamInst12_INIT_3D,
			INIT_3E => ProgMemInst_BRamInst12_INIT_3E,
			INIT_3F => ProgMemInst_BRamInst12_INIT_3F,
			WRITE_MODE => "WRITE_FIRST" --  WRITE_FIRST, READ_FIRST or NO_CHANGE
		)
			port map (
			DO => DoutxDO(12 downto 12),
			ADDR => AdrxDI,  		-- Address Input
			CLK => ClkxC,    		-- Clock
			DI => "0",      		-- Data Input
			EN => '1',      		-- RAM Enable Input
			SSR => RstxR,    		-- Synchronous Set/Reset Input
			WE => '0'       		-- Write Enable Input
		);       
		
		BRamInst13 : RAMB16_S1
		generic map (
			INIT => X"00000", --  Value of output RAM registers at startup
			SRVAL => X"00000", --  Ouput value upon SSR assertion
			INIT_00 => ProgMemInst_BRamInst13_INIT_00,
			INIT_01 => ProgMemInst_BRamInst13_INIT_01,
			INIT_02 => ProgMemInst_BRamInst13_INIT_02,
			INIT_03 => ProgMemInst_BRamInst13_INIT_03,
			INIT_04 => ProgMemInst_BRamInst13_INIT_04,
			INIT_05 => ProgMemInst_BRamInst13_INIT_05,
			INIT_06 => ProgMemInst_BRamInst13_INIT_06,
			INIT_07 => ProgMemInst_BRamInst13_INIT_07,
			INIT_08 => ProgMemInst_BRamInst13_INIT_08,
			INIT_09 => ProgMemInst_BRamInst13_INIT_09,
			INIT_0A => ProgMemInst_BRamInst13_INIT_0A,
			INIT_0B => ProgMemInst_BRamInst13_INIT_0B,
			INIT_0C => ProgMemInst_BRamInst13_INIT_0C,
			INIT_0D => ProgMemInst_BRamInst13_INIT_0D,
			INIT_0E => ProgMemInst_BRamInst13_INIT_0E,
			INIT_0F => ProgMemInst_BRamInst13_INIT_0F,
			INIT_10 => ProgMemInst_BRamInst13_INIT_10,
			INIT_11 => ProgMemInst_BRamInst13_INIT_11,
			INIT_12 => ProgMemInst_BRamInst13_INIT_12,
			INIT_13 => ProgMemInst_BRamInst13_INIT_13,
			INIT_14 => ProgMemInst_BRamInst13_INIT_14,
			INIT_15 => ProgMemInst_BRamInst13_INIT_15,
			INIT_16 => ProgMemInst_BRamInst13_INIT_16,
			INIT_17 => ProgMemInst_BRamInst13_INIT_17,
			INIT_18 => ProgMemInst_BRamInst13_INIT_18,
			INIT_19 => ProgMemInst_BRamInst13_INIT_19,
			INIT_1A => ProgMemInst_BRamInst13_INIT_1A,
			INIT_1B => ProgMemInst_BRamInst13_INIT_1B,
			INIT_1C => ProgMemInst_BRamInst13_INIT_1C,
			INIT_1D => ProgMemInst_BRamInst13_INIT_1D,
			INIT_1E => ProgMemInst_BRamInst13_INIT_1E,
			INIT_1F => ProgMemInst_BRamInst13_INIT_1F,
			INIT_20 => ProgMemInst_BRamInst13_INIT_10,
			INIT_21 => ProgMemInst_BRamInst13_INIT_21,
			INIT_22 => ProgMemInst_BRamInst13_INIT_22,
			INIT_23 => ProgMemInst_BRamInst13_INIT_23,
			INIT_24 => ProgMemInst_BRamInst13_INIT_24,
			INIT_25 => ProgMemInst_BRamInst13_INIT_25,
			INIT_26 => ProgMemInst_BRamInst13_INIT_26,
			INIT_27 => ProgMemInst_BRamInst13_INIT_27,
			INIT_28 => ProgMemInst_BRamInst13_INIT_28,
			INIT_29 => ProgMemInst_BRamInst13_INIT_29,
			INIT_2A => ProgMemInst_BRamInst13_INIT_2A,
			INIT_2B => ProgMemInst_BRamInst13_INIT_2B,
			INIT_2C => ProgMemInst_BRamInst13_INIT_2C,
			INIT_2D => ProgMemInst_BRamInst13_INIT_2D,
			INIT_2E => ProgMemInst_BRamInst13_INIT_2E,
			INIT_2F => ProgMemInst_BRamInst13_INIT_2F,
			INIT_30 => ProgMemInst_BRamInst13_INIT_30,
			INIT_31 => ProgMemInst_BRamInst13_INIT_31,
			INIT_32 => ProgMemInst_BRamInst13_INIT_32,
			INIT_33 => ProgMemInst_BRamInst13_INIT_33,
			INIT_34 => ProgMemInst_BRamInst13_INIT_34,
			INIT_35 => ProgMemInst_BRamInst13_INIT_35,
			INIT_36 => ProgMemInst_BRamInst13_INIT_36,
			INIT_37 => ProgMemInst_BRamInst13_INIT_37,
			INIT_38 => ProgMemInst_BRamInst13_INIT_38,
			INIT_39 => ProgMemInst_BRamInst13_INIT_39,
			INIT_3A => ProgMemInst_BRamInst13_INIT_3A,
			INIT_3B => ProgMemInst_BRamInst13_INIT_3B,
			INIT_3C => ProgMemInst_BRamInst13_INIT_3C,
			INIT_3D => ProgMemInst_BRamInst13_INIT_3D,
			INIT_3E => ProgMemInst_BRamInst13_INIT_3E,
			INIT_3F => ProgMemInst_BRamInst13_INIT_3F,
			WRITE_MODE => "WRITE_FIRST" --  WRITE_FIRST, READ_FIRST or NO_CHANGE
		)
			port map (
			DO => DoutxDO(13 downto 13),
			ADDR => AdrxDI,  		-- Address Input
			CLK => ClkxC,    		-- Clock
			DI => "0",      		-- Data Input
			EN => '1',      		-- RAM Enable Input
			SSR => RstxR,    		-- Synchronous Set/Reset Input
			WE => '0'       		-- Write Enable Input
		);           
		
		BRamInst14 : RAMB16_S1
		generic map (
			INIT => X"00000", --  Value of output RAM registers at startup
			SRVAL => X"00000", --  Ouput value upon SSR assertion
			INIT_00 => ProgMemInst_BRamInst14_INIT_00,
			INIT_01 => ProgMemInst_BRamInst14_INIT_01,
			INIT_02 => ProgMemInst_BRamInst14_INIT_02,
			INIT_03 => ProgMemInst_BRamInst14_INIT_03,
			INIT_04 => ProgMemInst_BRamInst14_INIT_04,
			INIT_05 => ProgMemInst_BRamInst14_INIT_05,
			INIT_06 => ProgMemInst_BRamInst14_INIT_06,
			INIT_07 => ProgMemInst_BRamInst14_INIT_07,
			INIT_08 => ProgMemInst_BRamInst14_INIT_08,
			INIT_09 => ProgMemInst_BRamInst14_INIT_09,
			INIT_0A => ProgMemInst_BRamInst14_INIT_0A,
			INIT_0B => ProgMemInst_BRamInst14_INIT_0B,
			INIT_0C => ProgMemInst_BRamInst14_INIT_0C,
			INIT_0D => ProgMemInst_BRamInst14_INIT_0D,
			INIT_0E => ProgMemInst_BRamInst14_INIT_0E,
			INIT_0F => ProgMemInst_BRamInst14_INIT_0F,
			INIT_10 => ProgMemInst_BRamInst14_INIT_10,
			INIT_11 => ProgMemInst_BRamInst14_INIT_11,
			INIT_12 => ProgMemInst_BRamInst14_INIT_12,
			INIT_13 => ProgMemInst_BRamInst14_INIT_13,
			INIT_14 => ProgMemInst_BRamInst14_INIT_14,
			INIT_15 => ProgMemInst_BRamInst14_INIT_15,
			INIT_16 => ProgMemInst_BRamInst14_INIT_16,
			INIT_17 => ProgMemInst_BRamInst14_INIT_17,
			INIT_18 => ProgMemInst_BRamInst14_INIT_18,
			INIT_19 => ProgMemInst_BRamInst14_INIT_19,
			INIT_1A => ProgMemInst_BRamInst14_INIT_1A,
			INIT_1B => ProgMemInst_BRamInst14_INIT_1B,
			INIT_1C => ProgMemInst_BRamInst14_INIT_1C,
			INIT_1D => ProgMemInst_BRamInst14_INIT_1D,
			INIT_1E => ProgMemInst_BRamInst14_INIT_1E,
			INIT_1F => ProgMemInst_BRamInst14_INIT_1F,
			INIT_20 => ProgMemInst_BRamInst14_INIT_10,
			INIT_21 => ProgMemInst_BRamInst14_INIT_21,
			INIT_22 => ProgMemInst_BRamInst14_INIT_22,
			INIT_23 => ProgMemInst_BRamInst14_INIT_23,
			INIT_24 => ProgMemInst_BRamInst14_INIT_24,
			INIT_25 => ProgMemInst_BRamInst14_INIT_25,
			INIT_26 => ProgMemInst_BRamInst14_INIT_26,
			INIT_27 => ProgMemInst_BRamInst14_INIT_27,
			INIT_28 => ProgMemInst_BRamInst14_INIT_28,
			INIT_29 => ProgMemInst_BRamInst14_INIT_29,
			INIT_2A => ProgMemInst_BRamInst14_INIT_2A,
			INIT_2B => ProgMemInst_BRamInst14_INIT_2B,
			INIT_2C => ProgMemInst_BRamInst14_INIT_2C,
			INIT_2D => ProgMemInst_BRamInst14_INIT_2D,
			INIT_2E => ProgMemInst_BRamInst14_INIT_2E,
			INIT_2F => ProgMemInst_BRamInst14_INIT_2F,
			INIT_30 => ProgMemInst_BRamInst14_INIT_30,
			INIT_31 => ProgMemInst_BRamInst14_INIT_31,
			INIT_32 => ProgMemInst_BRamInst14_INIT_32,
			INIT_33 => ProgMemInst_BRamInst14_INIT_33,
			INIT_34 => ProgMemInst_BRamInst14_INIT_34,
			INIT_35 => ProgMemInst_BRamInst14_INIT_35,
			INIT_36 => ProgMemInst_BRamInst14_INIT_36,
			INIT_37 => ProgMemInst_BRamInst14_INIT_37,
			INIT_38 => ProgMemInst_BRamInst14_INIT_38,
			INIT_39 => ProgMemInst_BRamInst14_INIT_39,
			INIT_3A => ProgMemInst_BRamInst14_INIT_3A,
			INIT_3B => ProgMemInst_BRamInst14_INIT_3B,
			INIT_3C => ProgMemInst_BRamInst14_INIT_3C,
			INIT_3D => ProgMemInst_BRamInst14_INIT_3D,
			INIT_3E => ProgMemInst_BRamInst14_INIT_3E,
			INIT_3F => ProgMemInst_BRamInst14_INIT_3F,
			WRITE_MODE => "WRITE_FIRST" --  WRITE_FIRST, READ_FIRST or NO_CHANGE
		)
			port map (
			DO => DoutxDO(14 downto 14),
			ADDR => AdrxDI,  		-- Address Input
			CLK => ClkxC,    		-- Clock
			DI => "0",      		-- Data Input
			EN => '1',      		-- RAM Enable Input
			SSR => RstxR,    		-- Synchronous Set/Reset Input
			WE => '0'       		-- Write Enable Input
		);   
		
		BRamInst15 : RAMB16_S1
		generic map (
			INIT => X"00000", --  Value of output RAM registers at startup
			SRVAL => X"00000", --  Ouput value upon SSR assertion
			INIT_00 => ProgMemInst_BRamInst15_INIT_00,
			INIT_01 => ProgMemInst_BRamInst15_INIT_01,
			INIT_02 => ProgMemInst_BRamInst15_INIT_02,
			INIT_03 => ProgMemInst_BRamInst15_INIT_03,
			INIT_04 => ProgMemInst_BRamInst15_INIT_04,
			INIT_05 => ProgMemInst_BRamInst15_INIT_05,
			INIT_06 => ProgMemInst_BRamInst15_INIT_06,
			INIT_07 => ProgMemInst_BRamInst15_INIT_07,
			INIT_08 => ProgMemInst_BRamInst15_INIT_08,
			INIT_09 => ProgMemInst_BRamInst15_INIT_09,
			INIT_0A => ProgMemInst_BRamInst15_INIT_0A,
			INIT_0B => ProgMemInst_BRamInst15_INIT_0B,
			INIT_0C => ProgMemInst_BRamInst15_INIT_0C,
			INIT_0D => ProgMemInst_BRamInst15_INIT_0D,
			INIT_0E => ProgMemInst_BRamInst15_INIT_0E,
			INIT_0F => ProgMemInst_BRamInst15_INIT_0F,
			INIT_10 => ProgMemInst_BRamInst15_INIT_10,
			INIT_11 => ProgMemInst_BRamInst15_INIT_11,
			INIT_12 => ProgMemInst_BRamInst15_INIT_12,
			INIT_13 => ProgMemInst_BRamInst15_INIT_13,
			INIT_14 => ProgMemInst_BRamInst15_INIT_14,
			INIT_15 => ProgMemInst_BRamInst15_INIT_15,
			INIT_16 => ProgMemInst_BRamInst15_INIT_16,
			INIT_17 => ProgMemInst_BRamInst15_INIT_17,
			INIT_18 => ProgMemInst_BRamInst15_INIT_18,
			INIT_19 => ProgMemInst_BRamInst15_INIT_19,
			INIT_1A => ProgMemInst_BRamInst15_INIT_1A,
			INIT_1B => ProgMemInst_BRamInst15_INIT_1B,
			INIT_1C => ProgMemInst_BRamInst15_INIT_1C,
			INIT_1D => ProgMemInst_BRamInst15_INIT_1D,
			INIT_1E => ProgMemInst_BRamInst15_INIT_1E,
			INIT_1F => ProgMemInst_BRamInst15_INIT_1F,
			INIT_20 => ProgMemInst_BRamInst15_INIT_10,
			INIT_21 => ProgMemInst_BRamInst15_INIT_21,
			INIT_22 => ProgMemInst_BRamInst15_INIT_22,
			INIT_23 => ProgMemInst_BRamInst15_INIT_23,
			INIT_24 => ProgMemInst_BRamInst15_INIT_24,
			INIT_25 => ProgMemInst_BRamInst15_INIT_25,
			INIT_26 => ProgMemInst_BRamInst15_INIT_26,
			INIT_27 => ProgMemInst_BRamInst15_INIT_27,
			INIT_28 => ProgMemInst_BRamInst15_INIT_28,
			INIT_29 => ProgMemInst_BRamInst15_INIT_29,
			INIT_2A => ProgMemInst_BRamInst15_INIT_2A,
			INIT_2B => ProgMemInst_BRamInst15_INIT_2B,
			INIT_2C => ProgMemInst_BRamInst15_INIT_2C,
			INIT_2D => ProgMemInst_BRamInst15_INIT_2D,
			INIT_2E => ProgMemInst_BRamInst15_INIT_2E,
			INIT_2F => ProgMemInst_BRamInst15_INIT_2F,
			INIT_30 => ProgMemInst_BRamInst15_INIT_30,
			INIT_31 => ProgMemInst_BRamInst15_INIT_31,
			INIT_32 => ProgMemInst_BRamInst15_INIT_32,
			INIT_33 => ProgMemInst_BRamInst15_INIT_33,
			INIT_34 => ProgMemInst_BRamInst15_INIT_34,
			INIT_35 => ProgMemInst_BRamInst15_INIT_35,
			INIT_36 => ProgMemInst_BRamInst15_INIT_36,
			INIT_37 => ProgMemInst_BRamInst15_INIT_37,
			INIT_38 => ProgMemInst_BRamInst15_INIT_38,
			INIT_39 => ProgMemInst_BRamInst15_INIT_39,
			INIT_3A => ProgMemInst_BRamInst15_INIT_3A,
			INIT_3B => ProgMemInst_BRamInst15_INIT_3B,
			INIT_3C => ProgMemInst_BRamInst15_INIT_3C,
			INIT_3D => ProgMemInst_BRamInst15_INIT_3D,
			INIT_3E => ProgMemInst_BRamInst15_INIT_3E,
			INIT_3F => ProgMemInst_BRamInst15_INIT_3F,
			WRITE_MODE => "WRITE_FIRST" --  WRITE_FIRST, READ_FIRST or NO_CHANGE
		)
			port map (
			DO => DoutxDO(15 downto 15),
			ADDR => AdrxDI,  		-- Address Input
			CLK => ClkxC,    		-- Clock
			DI => "0",      		-- Data Input
			EN => '1',      		-- RAM Enable Input
			SSR => RstxR,    		-- Synchronous Set/Reset Input
			WE => '0'       		-- Write Enable Input
		);
		
end Behavioral;

