								--------------------------------------------------------------------------------
-- Company: 
-- Engineer:
--
-- Create Date:   11:53:00 10/09/2010
-- Design Name:   
-- Module Name:   D:/e-/logic-analyzer/sump/xst/dram_test.vhd
-- Project Name:  sump
-- Target Device:  
-- Tool versions:  
-- Description:   
-- 
-- VHDL Test Bench Created by ISE for module: dram
-- 
-- Dependencies:
-- 
-- Revision:
-- Revision 0.01 - File Created
-- Additional Comments:
--
-- Notes: 
-- This testbench has been automatically generated using types std_logic and
-- std_logic_vector for the ports of the unit under test.  Xilinx recommends
-- that these types always be used for the top-level I/O of a design in order
-- to guarantee that the testbench will bind correctly to the post-implementation 
-- simulation model.
--------------------------------------------------------------------------------
LIBRARY ieee;
USE ieee.std_logic_1164.ALL;
USE ieee.std_logic_unsigned.all;
USE ieee.numeric_std.ALL;
 
ENTITY dramCtrl_test IS
END dramCtrl_test;
 
ARCHITECTURE arch_dram_test OF dramCtrl_test IS 
 
    -- Component Declaration for the Unit Under Test (UUT)
    COMPONENT dramCtrl
	 Generic(
			IS_SIMULATION	: string;
			WB_BURST_LEN	: integer);
    PORT(
			-- system interface
			ResetSwitchxR	: in  STD_LOGIC;	-- reset switch input (this comes from a push button)
	 		RstSocxRI		: in  STD_LOGIC;	-- logic reset for wishbone bus
			RstCorexRI		: in  STD_LOGIC;	-- logic reset for analyzer core (sampling clock domain)
			CalibDonexSO	: out STD_LOGIC;
			-- clocks
			BoardClkxCI 	: in  STD_LOGIC;	 -- positive of differential on board clock (200MHz)
		--	BoardClkxCIB	: in  STD_LOGIC;     -- negative of differential on board clock (200MHz)
			RefClkxCO		: out STD_LOGIC;	 -- PLL generated reference clock for the system (25MHz)
			-- interface to sampling core
			CoreClkxC		: in std_logic;	   	-- samplin system clock 100MHz
			DataxDI 		: in  std_logic_vector(31 downto 0);          
			WritexSI		: in std_logic;
			-- wishbone dma master interface
			WbClkxCI		: in std_logic;-- wishbone clock (master & slave)
			MaCycxSO		: out std_logic;
			MaStbxSO		: out std_logic;
			MaWexSO			: out std_logic;
			MaSelxDO		: out std_logic_vector(3 downto 0);
			MaAdrxDO		: out std_logic_vector(31 downto 0);
			MaDatxDO		: out std_logic_vector(31 downto 0);
			MaDatxDI		: in  std_logic_vector(31 downto 0);
			MaAckxSI		: in  std_logic;
			MaErrxSI		: in  std_logic;
			-- wishbone configuration slave interface
			SlCycxSI		: in  std_logic;
			SlStbxSI		: in  std_logic;
			SlWexSI			: in  std_logic;
			SlAdrxDI		: in  std_logic_vector(4 downto 2);
			SlDatxDI		: in  std_logic_vector(31 downto 0);
			SlDatxDO		: out std_logic_vector(31 downto 0);
			SlAckxSO		: out std_logic;
			IntxSO			: out std_logic;
			-- memory interface
			MemDQxDIO 		: INOUT  std_logic_vector(15 downto 0);
			MemAdrxDO 		: OUT  std_logic_vector(12 downto 0);
			MemBaxDO 		: OUT  std_logic_vector(2 downto 0);
			MemRasxEO 		: OUT  std_logic;
			MemCasxEO 		: OUT  std_logic;
			MemWexEO 		: OUT  std_logic;
			MemOdtxO 		: OUT  std_logic;
			MemCkexEO 		: OUT  std_logic;
			MemClkxCO 		: OUT  std_logic;
			MemClkxCOB 		: OUT  std_logic;
			MemLDqsxEO 		: INOUT  std_logic;
			MemLDqsxEOB 	: INOUT  std_logic;
			MemUDqsxEO 		: INOUT  std_logic;
			MemUDqsxEOB 	: INOUT  std_logic;
			MemLdmxEO 		: OUT  std_logic;
			MemUdmxEO 		: OUT  std_logic;
			RzqxIO 			: INOUT  std_logic;
			ZioxIO			: inout std_logic			
        );
    END COMPONENT;
    

	Component ddr2
--	Component ddr2_model_c3
	Port (
		ck		: in  std_logic;
		ck_n	: in  std_logic;
		cke		: in  std_logic;
		cs_n	: in  std_logic;
		ras_n	: in  std_logic;
		cas_n	: in  std_logic;
		we_n	: in  std_logic;
		dm_rdqs	: inout std_logic_vector(1 downto 0);  
		ba		: in  std_logic_vector(2 downto 0);
		addr	: in  std_logic_vector(12 downto 0);
		dq		: inout std_logic_vector(15 downto 0);
		dqs		: inout std_logic_vector(1 downto 0);
		dqs_n	: inout std_logic_vector(1 downto 0);
		rdqs_n	: out std_logic_vector(1 downto 0);
		odt		: in  std_logic
	);
	end component;

	--Inputs
	signal RstxRI : std_logic := '1';
	signal CalibDonexS : std_logic;
	signal MemClkxCI : std_logic := '0';
	signal MemClkxCIB : std_logic := '1';
	signal RefClkxCO : std_logic;
	signal ClkxC : std_logic := '0';
	signal DataxDI : std_logic_vector(31 downto 0) := (others => '0');
	signal WritexSI : std_logic := '0';

	--BiDirs
	signal MemDQxDIO : std_logic_vector(15 downto 0);
	signal MemLDqsxEO : std_logic;
	signal MemLDqsxEOB : std_logic;
	signal MemUDqsxEO : std_logic;
	signal MemUDqsxEOB : std_logic;
	signal RzqxIO : std_logic;
	signal ZioxIO : std_logic;

 	--Outputs
	signal RstxRO : std_logic;
	signal DataxDO : std_logic_vector(31 downto 0);
	signal DataReadyxSO : std_logic;
	signal MemAdrxDO : std_logic_vector(12 downto 0);
	signal MemBaxDO : std_logic_vector(2 downto 0);
	signal MemRasxEO : std_logic;
	signal MemCasxEO : std_logic;
	signal MemWexEO : std_logic;
	signal MemOdtxO : std_logic;
	signal MemCkexEO : std_logic;
	signal MemClkxCO : std_logic;
	signal MemClkxCOB : std_logic;
	signal MemLdmxEO : std_logic;
	signal MemUdmxEO : std_logic;
	
	-- Wishbone signals
	signal WbClkxC	: std_logic := '0';
	signal MaCycxSO	:  std_logic;
	signal MaStbxSO	:  std_logic;
	signal MaWexSO		:  std_logic;
	signal MaSelxDO	:  std_logic_vector(3 downto 0);
	signal MaAdrxDO	:  std_logic_vector(31 downto 0);
	signal MaDatxDO	:  std_logic_vector(31 downto 0);
	signal MaDatxDI	:   std_logic_vector(31 downto 0) := (others => '0');
	signal MaAckxSI	:   std_logic := '0';
	signal MaErrxSI	:   std_logic := '0';
			-- wishbone configuration slave interface
	signal SlCycxSI	:   std_logic := '0';
	signal SlStbxSI	:   std_logic := '0';
	signal SlWexSI		:   std_logic := '0';
	signal SlAdrxDI	:   std_logic_vector(4 downto 0) := (others => '0');
	signal SlDatxDI	:   std_logic_vector(31 downto 0) := (others => '0');
	signal SlDatxDO	:  std_logic_vector(31 downto 0);
	signal SlAckxSO	:  std_logic;
	signal IntxSO		:  std_logic;

	-- control signal for modelsim to stop simulation at end of testbench
	signal TBDone		: std_logic := '0';

	signal dqs : std_logic_vector(1 downto 0);
	signal dqs_n : std_logic_vector(1 downto 0);
	signal dm : std_logic_vector(1 downto 0);
 
BEGIN
 
	-- Instantiate the Unit Under Test (UUT)
	uut: dramCtrl 
	Generic map (
		IS_SIMULATION  => "TRUE",
		WB_BURST_LEN	=> 4
	)
	PORT MAP (
	-- system interface
		ResetSwitchxR	=> RstxRI,	-- reset switch input (this comes from a push button)
	 	RstSocxRI		=> RstxRI,	-- logic reset for wishbone bus
		RstCorexRI		=> RstxRI,	-- logic reset for analyzer core (sampling clock domain)
        CalibDonexSO 	=> CalibDonexS,
        BoardClkxCI 	=> MemClkxCI,
    --    BoardClkxCIB 	=> MemClkxCIB,
		RefClkxCO 		=> RefClkxCO,
        -- interface to sampling core
		CoreClkxC	=> ClkxC,
		DataxDI 	=> DataxDI,
		WritexSI	=> WritexSI,
		-- wishbone dma master interface
		WbClkxCI	=> WbClkxC,
		MaCycxSO	=> MaCycxSO,
		MaStbxSO	=> MaStbxSO,
		MaWexSO		=> MaWexSO,
		MaSelxDO	=> MaSelxDO,
		MaAdrxDO	=> MaAdrxDO,
		MaDatxDO	=> MaDatxDO,
		MaDatxDI	=> MaDatxDI,
		MaAckxSI	=> MaAckxSI,
		MaErrxSI	=> MaErrxSI,
		-- wishbone configuration slave interface
		SlCycxSI	=> SlCycxSI,
		SlStbxSI	=> SlStbxSI,
		SlWexSI		=> SlWexSI,
		SlAdrxDI	=> SlAdrxDI(4 downto 2),
		SlDatxDI	=> SlDatxDI,
		SlDatxDO	=> SlDatxDO,
		SlAckxSO	=> SlAckxSO,
		IntxSO		=>	IntxSO,
				
		MemDQxDIO => MemDQxDIO,
        MemAdrxDO => MemAdrxDO,
        MemBaxDO => MemBaxDO,
        MemRasxEO => MemRasxEO,
        MemCasxEO => MemCasxEO,
        MemWexEO => MemWexEO,
        MemOdtxO => MemOdtxO,
        MemCkexEO => MemCkexEO,
        MemClkxCO => MemClkxCO,
        MemClkxCOB => MemClkxCOB,
        MemLDqsxEO => MemLDqsxEO,
        MemLDqsxEOB => MemLDqsxEOB,
        MemUDqsxEO => MemUDqsxEO,
        MemUDqsxEOB => MemUDqsxEOB,
        MemLdmxEO => MemLdmxEO,
        MemUdmxEO => MemUdmxEO,
        RzqxIO => RzqxIO,
		ZioxIO => ZioxIO
    );
-- elpida memory model		
--	mem :  ede1116
--	PORT MAP (
--		cas_n => MemCasxEO,
--		ck => MemClkxCO,
--		ck_n => MemClkxCOB,
--		cke => MemCkexEO,
--		cs_n => '0',
--		ldm => MemLdmxEO,
--		odt => MemOdtxO,
--		ras_n => MemRasxEO,
--		udm => MemUdmxEO,
--		we_n => MemWexEO,
--		a => MemAdrxDO,
--		ba => MemBaxDO,
--		ldqs => MemLDqsxEO,
--		ldqs_n => MemLDqsxEOB,
--		udqs => MemUDqsxEO,
--		udqs_n => MemUDqsxEOB,
--		dq => MemDQxDIO
--	);
	-- micron memory model
	
--	mem : ddr2_model_c3
	mem : ddr2 
	Port map (
		ck => MemClkxCO,
		ck_n => MemClkxCOB,
		cke => MemCkexEO,
		cs_n => '0',
		ras_n => MemRasxEO,	
		cas_n => MemCasxEO,
		we_n => MemWexEO,
		dm_rdqs => dm,
		ba => MemBaxDO,
		addr => MemAdrxDO,
		dq => MemDQxDIO,
		dqs => dqs,
		dqs_n => dqs_n,
		rdqs_n => open,
		odt => MemOdtxO

	);

	dqs <= MemUDqsxEO & MemLDqsxEO;
	dqs_n <= MemUDqsxEO & MemLDqsxEO;
	dm <= MemUdmxEO & MemLdmxEO;
	
   -- 200MHz board clock
	boardClk : process
	begin
		MemClkxCI		<= '0';
		MemClkxCIB		<= '1';
		wait for 2500 ps;
		MemClkxCI		<= '1';
		MemClkxCIB		<= '0';
		wait for 2500 ps;
	end process;

	-- 100MHz system clock
	sysClk : process 
	begin
		ClkxC			<= '0';
		wait for 5 ns;
		ClkxC			<= '1';
		wait for 5 ns;
	end process; 

   -- 40MHz wishbone clock
	wbClk : process
	begin
		WbClkxC	<= '0';
		wait for 12.5 ns;
		WbClkxC	<= '1';
		wait for 12.5 ns;
	end process;
	
	-- generate ack signal for the wb master
--	wbAckGen : process (WbClkxC)
--	begin
--		if WbClkxC'event and WbClkxC='1' then
--			if MaCycxSO='1' and MaStbxSO='1' and MaAckxSI='0' then
--				MaAckxSI <= '1';
--			else
--				MaAckxSI <= '0';
--			end if;
--		end if;	
--	end process;
	MaAckxSI <= MaCycxSO and MaStbxSO;

   -- Stimulus process
   stim_proc: process
   begin		
      -- generate reset
	  wait for 1 us;
	  RstxRI <= '0';
	  -- wait until calibartion is done
	  --wait for 500 us;
	  --wait until ClkxC'event and ClkxC='1';	  
	  wait until RstxRO='0';
     wait until CalibDonexS='1';
	 
	  -- create a write 
	  wait until ClkxC'event and ClkxC='1';	  
	  DataxDI	<= x"01020304";
	  WritexSI	<= '1';
	  -- create a write
      wait until ClkxC'event and ClkxC='1';	  
	  DataxDI	<= x"05060708";
	  WritexSI	<= '1';
		-- create a write
      wait until ClkxC'event and ClkxC='1';	  
	  DataxDI	<= x"090a0b0c";
	  WritexSI	<= '1';
	  wait until ClkxC'event and ClkxC='1';	  
	  DataxDI	<= x"00000000";
	  WritexSI	<= '0';
	  -- create a write
      wait until ClkxC'event and ClkxC='1';	  
	  DataxDI	<= x"0d0e0f10";
	  WritexSI	<= '1';
	  wait until ClkxC'event and ClkxC='1';	  
	  DataxDI	<= x"00000000";
	  WritexSI	<= '0';
	  -- create a write
      wait until ClkxC'event and ClkxC='1';	  
	  DataxDI	<= x"11121314";
	  WritexSI	<= '1';
	  wait until ClkxC'event and ClkxC='1';	  
	  DataxDI	<= x"00000000";
	  WritexSI	<= '0';
	  -- create a write
      wait until ClkxC'event and ClkxC='1';	  
	  DataxDI	<= x"15161718";
	  WritexSI	<= '1';
	  wait until ClkxC'event and ClkxC='1';	  
	  DataxDI	<= x"00000000";
	  WritexSI	<= '0';
	  -- create a write
      wait until ClkxC'event and ClkxC='1';	  
	  DataxDI	<= x"191a1b1c";
	  WritexSI	<= '1';
	  wait until ClkxC'event and ClkxC='1';	  
	  DataxDI	<= x"00000000";
	  WritexSI	<= '0';
	  -- create a write
     wait until ClkxC'event and ClkxC='1';	  
	  DataxDI	<= x"1d1e1f20";
	  WritexSI	<= '1';
	  wait until ClkxC'event and ClkxC='1';	  
	  DataxDI	<= x"00000000";
	  WritexSI	<= '0';
	
	  wait for 100 ns;

	  -- set up an dma transfer
	  
	  -- set config flags
     wait until WbClkxC'event and WbClkxC='1';
	  SlCycxSI	<= '1';
	  SlStbxSI 	<= '1';
	  SlWexSI	<= '1';
	  SlAdrxDI	<= "00000";
	  SlDatxDI	<= x"0000000E";	-- E means clear error and done flag, set interrupt enable flag
	  wait until WbClkxC'event and WbClkxC='1' and SlAckxSO='1';
	  SlCycxSI	<= '0';
	  SlStbxSI 	<= '0';
	  SlWexSI	<= '0';
	 
	  -- set src address
     wait until WbClkxC'event and WbClkxC='1';
	  SlCycxSI	<= '1';
	  SlStbxSI 	<= '1';
	  SlWexSI	<= '1';
	  SlAdrxDI	<= "00100";
	  SlDatxDI	<= x"07fffff0";
	  wait until WbClkxC'event and WbClkxC='1' and SlAckxSO='1';
	  SlCycxSI	<= '0';
	  SlStbxSI 	<= '0';
	  SlWexSI	<= '0';
	  
	  -- set destination address
	  wait until WbClkxC'event and WbClkxC='1';
	  SlCycxSI	<= '1';
	  SlStbxSI 	<= '1';
	  SlWexSI	<= '1';
	  SlAdrxDI	<= "01000";
	  SlDatxDI	<= x"00008000";
	  wait until WbClkxC'event and WbClkxC='1' and SlAckxSO='1';
	  SlCycxSI	<= '0';
	  SlStbxSI 	<= '0';
	  SlWexSI	<= '0';
	  
	  -- length
	  -- set length
     wait until WbClkxC'event and WbClkxC='1';
	  SlCycxSI	<= '1';
	  SlStbxSI 	<= '1';
	  SlWexSI	<= '1';
	  SlAdrxDI	<= "01100";
	  SlDatxDI	<= x"00000008";
	  wait until WbClkxC'event and WbClkxC='1' and SlAckxSO='1';
	  SlCycxSI	<= '0';
	  SlStbxSI 	<= '0';
	  SlWexSI	<= '0';
	  
	  wait for 50 ns;
	  
	  -- read length
     wait until WbClkxC'event and WbClkxC='1';
	  SlCycxSI	<= '1';
	  SlStbxSI 	<= '1';
	  SlWexSI	<= '0';
	  SlAdrxDI	<= "01100";
	  SlDatxDI	<= x"00000000";
	  wait until WbClkxC'event and WbClkxC='1' and SlAckxSO='1';
	  SlCycxSI	<= '0';
	  SlStbxSI 	<= '0';
	  SlWexSI	<= '0';
	  
	  wait until IntxSO='1';
	  wait for 100 ns;
	  
	  -- set config flags to clear interrupt
     wait until WbClkxC'event and WbClkxC='1';
	  SlCycxSI	<= '1';
	  SlStbxSI 	<= '1';
	  SlWexSI	<= '1';
	  SlAdrxDI	<= "00000";
	  SlDatxDI	<= x"0000000E";	-- E means clear error and done flag, set interrupt enable flag
	  wait until WbClkxC'event and WbClkxC='1' and SlAckxSO='1';
	  SlCycxSI	<= '0';
	  SlStbxSI 	<= '0';
	  SlWexSI	<= '0';
	  
	  -- read config flags
     wait until WbClkxC'event and WbClkxC='1';
	  SlCycxSI	<= '1';
	  SlStbxSI 	<= '1';
	  SlWexSI	<= '0';
	  SlAdrxDI	<= "00000";
	  SlDatxDI	<= x"00000000";
	  wait until WbClkxC'event and WbClkxC='1' and SlAckxSO='1';
	  SlCycxSI	<= '0';
	  SlStbxSI 	<= '0';
	  SlWexSI	<= '0';
	  
	  -- read destination address
	  wait until WbClkxC'event and WbClkxC='1';
	  SlCycxSI	<= '1';
	  SlStbxSI 	<= '1';
	  SlWexSI	<= '0';
	  SlAdrxDI	<= "01000";
	  SlDatxDI	<= x"00000000";
	  wait until WbClkxC'event and WbClkxC='1' and SlAckxSO='1';
	  SlCycxSI	<= '0';
	  SlStbxSI 	<= '0';
	  SlWexSI	<= '0';
	  
	  -- read source address
	  wait until WbClkxC'event and WbClkxC='1';
	  SlCycxSI	<= '1';
	  SlStbxSI 	<= '1';
	  SlWexSI	<= '0';
	  SlAdrxDI	<= "00100";
	  SlDatxDI	<= x"00000000";
	  wait until WbClkxC'event and WbClkxC='1' and SlAckxSO='1';
	  SlCycxSI	<= '0';
	  SlStbxSI 	<= '0';
	  SlWexSI	<= '0';
	  
	  -- read the memory write address
	  wait until WbClkxC'event and WbClkxC='1';
	  SlCycxSI	<= '1';
	  SlStbxSI 	<= '1';
	  SlWexSI	<= '0';
	  SlAdrxDI	<= "10000";
	  SlDatxDI	<= x"00000000";
	  wait until WbClkxC'event and WbClkxC='1' and SlAckxSO='1';
	  SlCycxSI	<= '0';
	  SlStbxSI 	<= '0';
	  SlWexSI	<= '0';
	  
	  wait for 200 ns;
		
	  TBDone <= '1';

     wait;
   end process;

END;
